package ij.gui;

import java.awt.BasicStroke;

import java.awt.Graphics;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2011</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public abstract class AbstractRoi extends Object implements RoiBeans{

    protected abstract void grow(int sx, int sy);

    protected abstract void moveHandle(int sx, int sy);

    abstract void move(int sx, int sy);


    protected abstract void updateClipRect();

    protected abstract int clipRectMargin();
    protected abstract void handleMouseDrag(int sx, int sy, int flags);



    abstract void drawPreviousRoi(Graphics g);

    protected abstract void mouseDownInHandle(int handle, int sx, int sy);
    protected abstract void handleMouseDown(int sx, int sy);

    protected abstract void handleMouseUp(int screenX, int screenY);
    abstract void modifyRoi();
    abstract void addPoint();
    abstract void subtractPoints();


    protected abstract void showStatus();




    protected abstract BasicStroke getScaledStroke();


    // Used by the FileSaver and RoiEncoder to save overlay settings. */

     abstract void updatePaste();


    protected abstract double getMagnification();


    /** Returns a copy of this roi. See Thinking is Java by Bruce Eckel
            (www.eckelobjects.com) for a good description of object cloning. */
    public synchronized Object clone(){
        try {
                Roi r = (Roi)super.clone();
                return r;
        }
        catch (CloneNotSupportedException e) {return null;}
    }


    protected abstract int screenX(int ox);
    protected abstract int screenY(int oy);
    protected abstract int screenXD(double ox) ;
    protected abstract int screenYD(double oy) ;


}
