package ij.plugin.frame;
 import java.awt.BorderLayout;
 import java.awt.Color;
 import java.awt.Component;
 import java.awt.Container;
 import java.awt.Dimension;
 import java.awt.Font;
 import java.awt.FontMetrics;
 import java.awt.Graphics;
 import java.awt.Insets;
 import java.awt.MenuShortcut;
 import java.awt.Graphics2D;
 import java.awt.Toolkit;

 import java.awt.event.ActionEvent;
 import java.awt.event.ActionListener;
 import java.awt.event.ItemEvent;
 import java.awt.event.ItemEvent;
 import java.awt.event.InputEvent;
 import java.awt.event.FocusEvent;
 import java.awt.event.FocusListener;
 import java.awt.event.KeyEvent;
 import java.awt.event.KeyListener;
 import java.awt.event.MouseEvent;
 import java.awt.event.MouseListener;
 import java.awt.event.WindowEvent;
 import java.awt.event.MouseWheelListener;
 import java.awt.event.MouseWheelEvent;
 import java.awt.event.MouseMotionListener;

 import java.awt.datatransfer.Clipboard;																																																																																																																																																																																																																																																									 import java.util.*;
 import java.awt.datatransfer.Transferable;																																																																																																																																																																																																																																																									 import java.util.*;
 import java.awt.datatransfer.ClipboardOwner;

 import java.awt.font.FontRenderContext;
 import java.awt.font.TextLayout;
                                                                                                                                                                                                                                                          import java.util.*;
 import java.awt.print.PrinterException;
 import java.awt.print.PrinterJob;

 import java.beans.PropertyChangeEvent;
 import java.beans.PropertyChangeListener;

 import java.io.BufferedWriter;
 import java.io.BufferedReader;
 import java.io.CharArrayReader;
 import java.io.FileReader;
 import java.io.FileWriter;
 import java.io.File;
 import java.io.IOException;

 import java.net.URL;

 import java.text.AttributedCharacterIterator;
 import java.text.AttributedString;

 import javax.print.attribute.HashPrintRequestAttributeSet;
 import javax.print.attribute.PrintRequestAttributeSet;

 import javax.swing.event.CaretEvent;
 import javax.swing.event.CaretListener;
 import javax.swing.event.DocumentListener;
 import javax.swing.event.DocumentEvent;
 import javax.swing.event.UndoableEditEvent;
 import javax.swing.event.UndoableEditListener;
 import javax.swing.event.ChangeEvent;

 import javax.swing.text.JTextComponent;
 import javax.swing.text.Highlighter;
 import javax.swing.text.NavigationFilter;

 import javax.swing.text.DefaultStyledDocument;
 import javax.swing.text.StyleContext;
 import javax.swing.text.StyledEditorKit;

 import javax.swing.undo.CannotUndoException;
 import javax.swing.undo.CannotRedoException;
 import javax.swing.undo.UndoManager;
 import javax.swing.Action;
 import javax.swing.AbstractAction;
 import javax.swing.AbstractButton;
 import javax.swing.Box;
 import javax.swing.ButtonGroup;
 import javax.swing.Icon;
 import javax.swing.ImageIcon;
 import javax.swing.JButton;
 import javax.swing.JCheckBoxMenuItem;
 import javax.swing.JComponent;
 import javax.swing.JMenuBar;
 import javax.swing.JMenu;
 import javax.swing.JMenuItem;
 import javax.swing.JPopupMenu;
 import javax.swing.JScrollPane;
 import javax.swing.JToggleButton;
 import javax.swing.JViewport;
 import javax.swing.JToolBar;
 import javax.swing.KeyStroke;
 import javax.swing.JLabel;
 import javax.swing.JPanel;
 import javax.swing.JScrollBar;
 import javax.swing.border.BevelBorder;
 import javax.swing.border.Border;
 import javax.swing.BorderFactory;
 import javax.swing.JTextArea;
 import javax.swing.BoxLayout;
 import javax.swing.JLabel;
 import javax.swing.JTextPane;
 import javax.swing.JTabbedPane;
 import javax.swing.event.ChangeListener;
 import javax.swing.SingleSelectionModel;
 import javax.swing.JFrame;

 import ij.IJ;
 import ij.ImageJ;
 import ij.Menus;
 import ij.RecentOpener;
 import ij.WindowManager;
 import ij.IJ;
 import ij.gui.GenericDialog;
 import ij.gui.SaveChangesDialog;
 import ij.Prefs;
 import ij.util.Log;
 import ij.plugin.PlugIn;

 import ij.macro.Interpreter;
 import ij.macro.MacroConstants;
 import ij.macro.MacroRunner;
 import ij.plugin.MacroInstaller;
 import ij.plugin.NewPlugin;
 import ij.io.SaveDialog;
 import ij.plugin.frame.jedit.tokenmarker.*;
 import ij.plugin.frame.jedit.*;
 import ij.plugin.frame.jedit.syntax.*;
 import ij.plugin.frame.jedit.Mode;

 import ij2x.print.PrintableDocument;
 import com.microstar.xml.*;



/** This is a simple TextArea based editor for editing and compiling plugins. */
public class Editor extends PlugInFrame implements PlugIn,
        MouseListener, MouseMotionListener, MouseWheelListener, KeyListener, DocumentListener, CaretListener, MacroConstants, KeyCode, ClipboardOwner {

    private static ResourceBundle resources;
    /** ImportPackage statements added in front of scripts. Contains no
    newlines so that lines numbers in error messages are not changed. */
    public static String JavaScriptIncludes =
            "importPackage(Packages.ij);"+
            "importPackage(Packages.ij.gui);"+
            "importPackage(Packages.ij.process);"+
            "importPackage(Packages.ij.measure);"+
            "importPackage(Packages.ij.util);"+
            "importPackage(Packages.ij.plugin);"+
            "importPackage(Packages.ij.io);"+
            "importPackage(Packages.ij.plugin.filter);"+
            "importPackage(Packages.ij.plugin.frame);"+
            "importPackage(java.lang);"+
            "importPackage(java.awt);"+
            "importPackage(java.awt.image);"+
            "importPackage(java.awt.geom);"+
            "importPackage(java.util);"+
            "importPackage(java.io);"+
            "function print(s) {IJ.log(s);};";

    public static String JS_NOT_FOUND =
            "JavaScript.jar was not found in the plugins\nfolder. It can be downloaded from:\n \n"+IJ.URL+"/download/tools/JavaScript.jar";
    public static final int MAX_SIZE = 28000, MAX_MACROS=50, XINC=10, YINC=18;
    public static final int MONOSPACED=1, MENU_BAR=2;
    public static final int MACROS_MENU_ITEMS = 8;
    static final String FONT_SIZE = "editor.font.size";
    static final String FONT_MONO= "editor.font.mono";
    static final int PAGE_SCROLL = 18+1;

    private String path;
    private boolean changes=false;
    private static String searchString = "";
    private static int lineNumber = 1;
    private static int xoffset, yoffset;
    private static int nWindows;
    private JMenu fileMenu, editMenu, runMenu;
    private Properties p = new Properties();

    private JMenuBar mb = new JMenuBar();
    private JScrollPane scrollPane;
    private JViewport port;
    private JMenu macrosMenu;
    private static JMenu recentMenu;
    private static JMenuItem recentDefault;
    private static boolean isrecent=true;


    private MacroInstaller installer;
    private static String defaultDir;
    //private int[] sizes = {8, 9, 10, 11, 12, 14, 16, 18, 20, 24, 36, 48, 60, 72};
    private int[] sizes = {6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 20, 22, 24, 26, 28, 30};
    private static int fontSize = (int)Prefs.get(FONT_SIZE, 6);
    //private TextLayout layout;
    //private FontRenderContext frc;
    private static boolean caseSensitive = true;
    private static boolean wholeWords;
    private JCheckBoxMenuItem monospaced;
    private boolean dontShowWindow;
    private JPopupMenu popup;
    boolean enable=true;
    private Hashtable<Object, Action> commands;
    private Hashtable<String, JMenuItem> menuItems;
    private JMenuBar menubar;
    private JToolBar toolbar;

    private JLabel statusLabel;
    private ButtonGroup group = new ButtonGroup();

    private boolean isMacroWindow;

    //private Highlighter highlighter;
    //private NavigationFilter navigation;
    private int num =0, length=0, lnwidth=40;
    //private String[] lines = new String[1];

    public int row = 1;
    private StringBuilder sb;
    private String text = "", clone = "", fileName;

    private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    private Border grayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.gray, Color.lightGray);

    private Font curFont;
    private FontMetrics fm;
    private int curRow=1;
    private JEditTextArea editor;

    public static Editor focusedComponent;
    private SyntaxDocument doc, olddoc;
    //private AttributedString attribString;
    //private AttributedCharacterIterator attribCharIterator;
    private Container container;
    private JEditor jEditor;
    private JSyntaxStyleTree jSyntaxStyleTree;
    private static JTextComponent messagesEditor;
    private JTabbedPane tabbedpane, treeTabbedpane;
    private boolean macroIsInstalled;
    private boolean compilerIsInstalled;
    private boolean isDragged = false;
    private static Vector modes;
    //private ImageJ ij;
    private Clipboard cb;


        static {
            try {
                resources = ResourceBundle.getBundle("ij.plugin.frame.resources.Editor",
                                                     Locale.getDefault());
            } catch (MissingResourceException mre) {
                System.err.println("resources/Editor.properties not found");
                System.exit(1);
            }
        }
        public void run(String arg) {
         // your code!
        }
        public void run() {

           this.container=super.getContentPane();
           this.container.setLayout(new BorderLayout());

           jEditor = new JEditor();
           jSyntaxStyleTree = new JSyntaxStyleTree();

           commands = new Hashtable<Object, Action>();
           menuItems = new Hashtable<String, JMenuItem>();

           //this.addKeyListener(IJ.getInstance());  // ImageJ handles keyboard shortcuts
           Action[] actions = defaultActions;
           for (int i = 0; i < actions.length; i++) {
               Action a = actions[i];
               //System.out.println("Action.NAME("+i+")="+a.getValue(Action.NAME));
               commands.put(a.getValue(Action.NAME), a);
           }

           JMenuBar menuBar = createMenubar();
           this.setJMenuBar(menuBar);

           toolbar = (JToolBar)createToolbar();
           toolbar.setVisible(false);
           //toolbar.setFocusable(false);
           //toolbar.addNotify();

           this.container.add(toolbar, BorderLayout.NORTH);

           createPopupMenus();

           editor= (JEditTextArea)createEditor();
           editor.setBorder(grayBorder);
           /*editor.addMouseWheelListener(this);
           editor.painter.addMouseMotionListener(this);
           editor.painter.addMouseListener(this);
           editor.setBorder(grayBorder);
           editor.addCaretListener(this);
           frc = new FontRenderContext(null, false, false);
           editor.setFocusable(true);
           editor.setFocusCycleRoot(editor.isFocusable());
           editor.addNotify();*/

            /*items=new String[1];
            items[0]="";
            it = Arrays.asList(items).iterator();

            list = new AnimatedJList ();

            while (it.hasNext())
                model.addElement (it.next());

            list.setModel(model);
            list.addListSelectionListener(new ListSelectionListener(){
                   public void valueChanged(ListSelectionEvent e){
                        int index = 0;
                        if (e.getValueIsAdjusting()
                                  && WindowManager.getCurrentImage()!=null
                                         && !ignoreInterrupts) {
                            JList list = (JList)e.getSource();
                    try {
                        index = list.getSelectedIndex();
                        if (index<0) index = 0;
                        if (!IJ.shiftKeyDown() && !IJ.isMacintosh()) {
                                int[] indexes = list.getSelectedIndices();
                                for (int i=0; i<indexes.length; i++) {
                                        if (indexes[i]!=index)
                                                list.setSelectedIndex(indexes[i]);
                                }
                        }
                        if (WindowManager.getCurrentImage()!=null) {
                                //restore(index, true);
                                if (Recorder.record) Recorder.record("roiManager", "Select", index);
                              }
                    }
                    catch (NumberFormatException ex) {
                        ex.printStackTrace();
                    }
                    }
            }
            });
            list.addKeyListener(ij);
            list.addMouseListener(new MouseAdapter(){
            public void mousePressed(MouseEvent e){
                int x=e.getX(), y=e.getY();
                if (e.isPopupTrigger() || e.isMetaDown())
                        pm.show(e.getComponent(),x,y);
            }
            });
            list.addMouseWheelListener(this);

           treeTabbedpane = new JTabbedPane();
           treeTabbedpane.add("SyntaxStyleTree", null);
           treeTabbedpane.getModel().addChangeListener(
              new ChangeListener() {
                 public void stateChanged(ChangeEvent e) {
                     SingleSelectionModel model = (SingleSelectionModel) e.getSource();
                     if(model.getSelectedIndex() == treeTabbedpane.getTabCount()-1) {
                         //heer your methods
                     }
                 }
              }
           );*/

           messagesEditor=createMessagesEditor();

           scrollPane = new JScrollPane();
           port=scrollPane.getViewport();
           port.add(messagesEditor, null);

           tabbedpane = new JTabbedPane();
           tabbedpane.add("messages", scrollPane);
           tabbedpane.getModel().addChangeListener(
              new ChangeListener() {
                 public void stateChanged(ChangeEvent e) {
                     SingleSelectionModel model = (SingleSelectionModel) e.getSource();
                     if(model.getSelectedIndex() == tabbedpane.getTabCount()-1) {
                         //heer your methods
                     }
                 }
              }
           );
           tabbedpane.setFocusable(false);
           tabbedpane.setFocusCycleRoot(tabbedpane.isFocusable());
           tabbedpane.addNotify();
           //jSyntaxStyleTree.add(treeTabbedpane);
           jSyntaxStyleTree.add(editor);
           jEditor.add(jSyntaxStyleTree);
           jEditor.add(tabbedpane);

           this.container.add(jEditor, BorderLayout.CENTER);

           statusLabel=new JLabel(" ");
           JPanel statusPanel = createStatusBar(statusLabel);
           this.container.add(statusPanel, BorderLayout.SOUTH);

           positionWindow();
           WindowManager.addWindow(this);
           this.pack();
           editor.painter.setFont(new Font("DialogInput",Font.PLAIN,12));
           this.setVisible(true);
           toolbar.setVisible(true);
           //toolbar.setFocusable(true);
           //toolbar.removeNotify();
           Editor.this.focusedComponent=this;
           IJ.register(Editor.class);
        }

        public Editor() {
            super("Editor");
            run();
        }

        /**
         * FIXME - I'm not very useful yet
         */
        /**/public class JEditor extends JComponent {

            public JEditor() {
                super();
                setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
            }

            public void paint(Graphics g) {
                super.paint(g);
            }

        }

        /**
         * FIXME - I'm not very useful yet
         */
        /**/public class JSyntaxStyleTree extends JComponent {

            public JSyntaxStyleTree() {
                super();
                setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
            }

            public void paint(Graphics g) {
                super.paint(g);
            }

        }

        /**
         * Create an editor to represent the given document.
         */
        protected JTextComponent createMessagesEditor() {
            StyleContext sc = new StyleContext();
            //Style defaultStyle = sc.getStyle(StyleContext.DEFAULT_STYLE);
            DefaultStyledDocument doc = new DefaultStyledDocument(sc);
            JTextComponent txtcomp = new JTextArea(5, 80);
            txtcomp.setFont(new Font("SansSerif",Font.PLAIN,11));
            txtcomp.setDragEnabled(true);
            txtcomp.setFocusable(false);
            txtcomp.setFocusCycleRoot(txtcomp.isFocusable());
            txtcomp.addNotify();
            txtcomp.setBorder(grayBorder);
            txtcomp.setBackground(new Color(255, 255, 235));
            return txtcomp;
        }
        /**
         * Create an editor to represent the given document.
         */
        protected JComponent createEditor() {
            JEditTextArea editor= new JEditTextArea(this, TextAreaDefaults.getDefaults());
            editor.addMouseWheelListener(this);
            editor.painter.addMouseMotionListener(this);
            editor.painter.addMouseListener(this);
            editor.addCaretListener(this);
            //frc = new FontRenderContext(null, false, false);
            editor.setFocusable(true);
            editor.setFocusCycleRoot(editor.isFocusable());
            editor.addNotify();
            return editor;
        }

        /** Override Container getInsets() to make room for some text above the image. */
        public Insets getInsets() {
                Insets insets = super.getInsets();
                insets = new Insets(insets.top, insets.left, insets.bottom, insets.right);
                return insets;
        }
        /**
         * Fetch the editor contained in this panel
         */
        protected JEditTextArea getEditor() {
            return editor;
        }
        /**
        * Fetch the list of actions supported by this
        * editor.  It is implemented to return the list
        * of actions supported by the embedded JTextComponent
        * augmented with the actions defined locally.
        */
       //public Action[] getActions() {
       //    return TextAction.augmentList(getActions(), defaultActions);
      // }
       protected Action getAction(String cmd) {
           return commands.get(cmd);
       }
       protected String getResourceString(String nm) {
           String str;
           try {
               str = resources.getString(nm);
           } catch (MissingResourceException mre) {
               str = null;
           }
           return str;
       }

       /**
        * Create a status bar
        */
       protected JPanel createStatusBar(JLabel label){
          JPanel panel = new JPanel();
          panel.setLayout(new BorderLayout());
          panel.add(BorderLayout.EAST, label);
         return panel;
       }

       protected Container getToolbar() {
          return toolbar;
      }

      protected JMenuBar getMenubar() {
          return menubar;
      }

      /**
       * Fetch the menu item that was created for the given
       * command.
       * @param cmd  Name of the action.
       * @returns item created for the given command or null
       *  if one wasn't created.
       */
      protected JMenuItem getMenuItem(String cmd) {
          return menuItems.get(cmd);
      }

      protected URL getResource(String key) {
           String name = getResourceString(key);
           if (name != null) {
               URL url = this.getClass().getResource(name);
               return url;
           }
           return null;
       }

       /**
        * Take the given string and chop it up into a series
        * of strings on whitespace boundaries.  This is useful
        * for trying to get an array of strings out of the
        * resource file.
        */
       protected String[] tokenize(String input) {
           Vector<String> v = new Vector<String>();
           StringTokenizer t = new StringTokenizer(input);
           String cmd[];

           while (t.hasMoreTokens())
               v.addElement(t.nextToken());
           cmd = new String[v.size()];
           for (int i = 0; i < cmd.length; i++)
               cmd[i] = v.elementAt(i);

           return cmd;
       }

       /**
        * Resets the undo manager.
        */
       protected void resetUndoManager() {
           undo.discardAllEdits();
           undoAction.update();
           redoAction.update();
       }

       /**
        * Create the toolbar.  By default this reads the
        * resource file for the definition of the toolbar.
        */
       private Component createToolbar() {
           toolbar = new JToolBar();
           boolean isbutton=true;
           String[] toolKeys = tokenize(getResourceString("toolbar"));
           for (int i = 0; i < toolKeys.length; i++) {
               if (toolKeys[i].equals("-")) {
                   toolbar.add(Box.createHorizontalStrut(5));
               } else {
                   String bot= getResourceString(toolKeys[i] + "Button");
                   if(bot!=null){
                       Boolean shifts = Boolean.valueOf(bot);
                       isbutton = shifts.booleanValue();
                   }//else isbutton=false;
                   toolbar.add(createTool(toolKeys[i], isbutton));
               }
           }
           toolbar.add(Box.createHorizontalGlue());
           return toolbar;
       }

       /**
        * Hook through which every toolbar item is created.
        */
       protected Component createTool(String key, boolean isbutton) {
           return createToolbarButton(key, isbutton);
       }

       /**
        * Create a button to go inside of the toolbar.  By default this
        * will load an image resource.  The image filename is relative to
        * the classpath (including the '.' directory if its a part of the
        * classpath), and may either be in a JAR file or a separate file.
        *
        * @param key The key in the resource file to serve as the basis
        *  of lookups.
        */
       protected Component createToolbarButton(String key, boolean isbutton) {
           URL url = getResource(key + imageSuffix);
           boolean enabled=true;
           //System.out.println("url=" +url);
           AbstractButton b = null;
           if(isbutton){
              JButton jb = new JButton(new ImageIcon(url)) {
                   public float getAlignmentY() { return 0.5f; }
               };b=jb;}
           else{
              JToggleButton jtb = new JToggleButton("", new ImageIcon(url), false) {
                   public float getAlignmentY() { return 0.5f; }
               };b=jtb;}
           b.setRequestFocusEnabled(false);
           b.setMargin(new Insets(1,1,1,1));

           String astr = getResourceString(key + actionSuffix);
           if (astr == null) {
               astr = key;
           }
           Action a = getAction(astr);
           if (a != null) {
               b.setActionCommand(astr);
               a.addPropertyChangeListener(createActionChangeListener(b));
               b.addActionListener(a);
           } else {
               b.setEnabled(false);
           }

           String tip = getResourceString(key + tipSuffix);
           if (tip != null) {
               b.setToolTipText(tip);
           }
           String sev = getResourceString(key + undoSuffix);
           if(sev!=null){
               Boolean ev = Boolean.valueOf(sev);
               enabled = ev.booleanValue();
               b.setEnabled(enabled);
           }
           //if(astr.equals("Undo") || astr.equals("Redo"))
           //    b.setEnabled(enabled);

           return b;
       }

       /**
        * Create the menubar for the app.  By default this pulls the
        * definition of the menu from the associated resource file.
        */
       protected JMenuBar createMenubar() {
           JMenuItem mi;
           JMenuBar mb = new JMenuBar();

           String[] menuKeys = tokenize(getResourceString("menubar"));
           for (int i = 0; i < menuKeys.length; i++) {
               //System.out.println("menuKeys[i]="+menuKeys[i]);
               //if(menuKeys[i].equals("color")){mb.add(createColorMenu(menuKeys[i]));continue;}
               JMenu m = createMenu(menuKeys[i]);
               if (m != null) {
                   mb.add(m);
               }
           }
           this.menubar = mb;
           return mb;
       }

       void createCheckBoxMenuItem(JMenu menu, String colorName, Color color, boolean state){
           ActionListener a;
           JCheckBoxMenuItem cb;
           String colorname=colorName.toLowerCase();
           cb = new JCheckBoxMenuItem(resources.getString(colorName));
           cb.setHorizontalTextPosition(JButton.RIGHT);
           cb.setIcon(new ColoredSquare(color));
           a = new StyledEditorKit.ForegroundAction("set-foreground-"+ colorname, color);
           cb.addActionListener(a);
           group.add(cb);
           cb.setState(state);
           menu.add(cb);
       }
       /**
         * Create a color menu for the app.  By default this pulls the
         * definition of the menu from the associated resource file.
         */
     /*JMenu createColorMenu(String key) {
         JMenu menu = new JMenu(getResourceString(key + labelSuffix));
         createCheckBoxMenuItem(menu, "Red", Color.red, false);
         createCheckBoxMenuItem(menu, "Green", Color.green, false);
         createCheckBoxMenuItem(menu, "Blue", Color.blue, false);
         menu.addSeparator();
         createCheckBoxMenuItem(menu, "Black", Color.black, true);

         return menu;
     }*/
      /**
        * Create a menu for the app.  By default this pulls the
        * definition of the menu from the associated resource file.
        */
       protected JMenu createMenu(String key) {
           boolean shift = false;
           String[] itemKeys = tokenize(getResourceString(key));
           int[] shortCutitemKeys = new int[itemKeys.length];
           int j=0;
           JMenu menu = new JMenu(getResourceString(key + "Label"));
           for (int i = 0; i < itemKeys.length; i++) {
               if (itemKeys[i].equals("-")) {
                   menu.addSeparator();
               } else if(itemKeys[i].equals("monospaced")){
                   JCheckBoxMenuItem checkmi = createCheckBoxMenuItem(itemKeys[i]);
                   monospaced=checkmi;
                   menu.add(checkmi);
               }
               else if(itemKeys[i].equals("recent")){
                   addOpenRecentSubMenu(menu);
                   }
                   else{
                   String sc = getResourceString(itemKeys[i] + "Shortcut");
                   if(sc!=null){
                       for(j=0; j<shortcutKeys.length;j++){
                           if (sc.equals(shortcutKeys[j]))
                               shortCutitemKeys[i] = shortcutKeyi[j];
                       }
                   }
                   String ssc= getResourceString(itemKeys[i] + "ShiftShortcut");
                   if(ssc!=null){
                       Boolean shifts = Boolean.valueOf(ssc);
                       shift = shifts.booleanValue();
                   }else shift=false;
                   //System.out.println(" shortCutitemKeys["+i+"]="+ shortCutitemKeys[i]);
                   JMenuItem mi = createMenuItem(itemKeys[i], shortCutitemKeys[i], shift);
                   menu.add(mi);
               }
           }
           if(menu.getText().equals("File"))
                this.fileMenu=menu;
            else if(menu.getText().equals("Edit"))
                this.editMenu=menu;
            else if(menu.getText().equals("Run"))
                this.runMenu=menu;
           return menu;
       }

       void addOpenRecentSubMenu(JMenu menu) {
               String RECENT = "recent";
               recentMenu = new JMenu("Open Recent");
               URL url = getResource(RECENT + imageSuffix);
               recentMenu.setIcon(new ImageIcon(url));
               int count=0;
               for (int i=0; i<Menus.MAX_OPEN_RECENT_ITEMS; i++) {
                       final String path = Prefs.getString(RECENT + (i/10)%10 + i%10);
                       if (path==null) break;
                       count=i+1;
                       JMenuItem item = new JMenuItem(path);
                       item.setName("Open Recent");
                       recentMenu.add(item);
                       item.addActionListener(new ActionListener(){
                       public void actionPerformed(ActionEvent e){
                           new RecentOpener(path); // open image in separate thread
                           return;
                       }
                       });
               }
               if(isrecent && count >= 1){
                   addOpenRecentDefaultItem(recentMenu, count);
               }
               menu.add(recentMenu);
       }
       /** Adds a file path to the beginning of the File/Open Recent submenu. */
       public synchronized void addOpenRecentItem(String path) {
           String RECENT = "recent";
               final String fpath = path;
               int count = recentMenu.getItemCount();
               if(isrecent)
               addOpenRecentDefaultItem(recentMenu, count);
               if(count > 1 ){
                   for (int i=0; i<Menus.MAX_OPEN_RECENT_ITEMS; i++) {
                           String prepath = Prefs.getString(RECENT + (i/10)%10 + i%10);
                           if (prepath==null) break;
                           //if(prepath.equals(path))break;
                   }
                   for (int i = 0; i < count-2; i++){
                       if (recentMenu.getItem(i).getText().equals(path)){
                           recentMenu.remove(i);count--;
                           break;
                       }
                   }
               }
               if ((count-2)==Menus.MAX_OPEN_RECENT_ITEMS)
                       recentMenu.remove(Menus.MAX_OPEN_RECENT_ITEMS-1);
               JMenuItem item = new JMenuItem(path);
               item.setName(recentMenu.getText());
               recentMenu.insert(item, 0);
               item.addActionListener(new ActionListener(){
               public void actionPerformed(ActionEvent e){
                   new RecentOpener(fpath); // open image in separate thread
                   return;
               }
               });
       }

       public void addOpenRecentDefaultItem(JMenu recentMenu, int count) {
           final JMenu frecentMenu = recentMenu;
            if(isrecent) {
              recentDefault = new JMenuItem("Clear All Item");//
              recentDefault.setName("clearall");
              recentMenu.insertSeparator(count + 1);
              recentMenu.insert(recentDefault, count + 2);
              isrecent=false;
          }
          recentDefault.addActionListener(new ActionListener(){
          public void actionPerformed(ActionEvent e){
              frecentMenu.removeAll();
              isrecent=true;
              path=null;
          }
          });
       }

       /**
        * This is the hook through which all menu items are
        * created.  It registers the result with the menuitem
        * hashtable so that it can be fetched with getMenuItem().
        * @see #getMenuItem
        */
       protected JMenuItem createMenuItem(String cmd) {
           JMenuItem mi = new JMenuItem(getResourceString(cmd + labelSuffix));
           URL url = getResource(cmd + imageSuffix);
           if (url != null) {
               mi.setHorizontalTextPosition(JButton.RIGHT);
               mi.setIcon(new ImageIcon(url));
           }
           String astr = getResourceString(cmd + actionSuffix);
           if (astr == null) {
               astr = cmd;
           }
           //System.out.println("astr=" + astr);
           mi.setActionCommand(astr);
           Action a = getAction(astr);
           if (a != null) {
               mi.addActionListener(a);
               a.addPropertyChangeListener(createActionChangeListener(mi));
               mi.setEnabled(a.isEnabled());
           } else {
               mi.setEnabled(false);
           }
           menuItems.put(cmd, mi);
           return mi;
       }

       /**
        * This is the hook through which all menu items are
        * created.  It registers the result with the menuitem
        * hashtable so that it can be fetched with getMenuItem().
        * @see #getMenuItem
        */
       protected JCheckBoxMenuItem createCheckBoxMenuItem(String cmd) {
           JCheckBoxMenuItem mi = new JCheckBoxMenuItem(getResourceString(cmd + labelSuffix));
           URL url = getResource(cmd + imageSuffix);
           if (url != null) {
               mi.setHorizontalTextPosition(JButton.RIGHT);
               mi.setIcon(new ImageIcon(url));
           }
           String astr = getResourceString(cmd + actionSuffix);
           if (astr == null) {
               astr = cmd;
           }
           mi.setActionCommand(astr);
           Action a = getAction(astr);
           if (a != null) {
               mi.addActionListener(a);
               a.addPropertyChangeListener(createActionChangeListener(mi));
               mi.setEnabled(a.isEnabled());
           } else {
               mi.setEnabled(false);
           }
           menuItems.put(cmd, mi);
           return mi;
       }

       /**
        * This is the hook through which all popup menu items are
        * created.  It registers the result with the menuitem
        * hashtable so that it can be fetched with createMenuItem().
        * @see #createMenuItem
        */
       void createPopupMenus() {
               popup=new JPopupMenu();
       String[] itemKeys = tokenize(getResourceString("popupmenu"));
       for (int i = 0; i < itemKeys.length; i++) {
           if (itemKeys[i].equals("-")) {
               popup.addSeparator();
           } else {
               JMenuItem mi = createMenuItem(itemKeys[i]);
               popup.add(mi);
           }
         }
         TextAreaDefaults.getDefaults().popup=popup;
       }
       /**
        * This is the hook through which all menu items are
        * created.  It registers the result with the menuitem
        * hashtable so that it can be fetched with getMenuItem().
        * @see #getMenuItem
        */
       protected JMenuItem createMenuItem(String cmd, int shortcut, boolean shift) {
           int trueshortcutkeyInt =  new MenuShortcut(shortcut, true).getKey();
           int shortcutkeyInt =  new MenuShortcut(shortcut, false).getKey();
           JMenuItem mi = new JMenuItem(getResourceString(cmd + labelSuffix));
           if (shortcut==0)
                   mi = new JMenuItem(getResourceString(cmd + labelSuffix));
           else {
                   if (shift) {
                           mi = new JMenuItem(getResourceString(cmd + labelSuffix));//, trueshortcutkeyInt);
                           mi.setAccelerator(
                             KeyStroke.getKeyStroke(trueshortcutkeyInt, InputEvent.CTRL_MASK | InputEvent.SHIFT_MASK) );
                   } else {
                           mi = new JMenuItem(getResourceString(cmd + labelSuffix));//, shortcutkeyInt);
                           mi.setAccelerator(
                             KeyStroke.getKeyStroke(shortcutkeyInt, InputEvent.CTRL_MASK) );
                   }
           }
           URL url = getResource(cmd + imageSuffix);
           if (url != null) {
               mi.setHorizontalTextPosition(JButton.RIGHT);
               mi.setIcon(new ImageIcon(url));
           }
           String astr = getResourceString(cmd + actionSuffix);
           if (astr == null) {
               astr = cmd;
           }
           mi.setActionCommand(astr);
           Action a = getAction(astr);
           if (a != null) {
               mi.addActionListener(a);
               a.addPropertyChangeListener(createActionChangeListener(mi));
               mi.setEnabled(a.isEnabled());
           } else {
               mi.setEnabled(false);
           }
           menuItems.put(cmd, mi);
           return mi;
       }

        // Yarked from JMenu, ideally this would be public.
        protected PropertyChangeListener createActionChangeListener(AbstractButton b) {
            return new ActionChangedListener(b);
        }

        // Yarked from JMenu, ideally this would be public.
        private class ActionChangedListener implements PropertyChangeListener {
            AbstractButton abstractItem;

            ActionChangedListener(AbstractButton mi) {
                super();
                this.abstractItem = mi;
            }
            public void propertyChange(PropertyChangeEvent e) {
                String propertyName = e.getPropertyName();
                //System.out.println("propertyName=" +propertyName);
               if (e.getPropertyName().equals(Action.NAME)) {
                    //String text = (String) e.getNewValue();
                    //abstractItem.setText(text);
                } else if (propertyName.equals("enabled")) {
                    Boolean enabledState = (Boolean) e.getNewValue();
                    //System.out.println("abstractItem=" +abstractItem);
                    abstractItem.setEnabled(enabledState.booleanValue());
                }
            }
        }


        public void positionWindow() {
                Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
                //Dimension window = getSize();
                Dimension window = this.getPreferredSize();
                if (window.width==0)
                        return;
                int left = screen.width/2-window.width/2;
                int top = (screen.height-window.height)/4;
                if (top<0) top = 0;
                if (nWindows<=0 || xoffset>8*XINC)
                        {xoffset=0; yoffset=0;}
                setLocation(left+xoffset, top+yoffset);
                xoffset+=XINC; yoffset+=YINC;
                nWindows++;
        }

        void setWindowTitle(String title) {
                Menus.updateWindowMenuItem(getTitle(), title);
                setTitle(title);
        }

        void selectTockenMarker(String fileName){

            fileName=fileName.toLowerCase();

            if (fileName.endsWith(".bat")) {
                doc.setTokenMarker(new BatchFileTokenMarker());
            }
            else if (fileName.endsWith(".cpp")) {
                doc.setTokenMarker(new CCTokenMarker());
            }
            else if (fileName.endsWith(".c")) {
                doc.setTokenMarker(new CTokenMarker());
            }
            else if (fileName.endsWith(".html") || fileName.endsWith(".htm") || fileName.endsWith(".shtml") || fileName.endsWith(".shtm") || fileName.endsWith(".xhtml")|| fileName.endsWith(".jsp")) {
                doc.setTokenMarker(new XHTMLTokenMarker());
            }
            else if (fileName.endsWith(".idl") || fileName.endsWith(".cs")) {
                doc.setTokenMarker(new IDLTokenMarker());
            }
            else if (fileName.endsWith(".js")) {
                doc.setTokenMarker(new JavaScriptTokenMarker());
            }
            else if (fileName.endsWith(".java") || fileName.endsWith(".bsh") || fileName.endsWith(".cmd")) {//bsh == bean shell macrosript
                doc.setTokenMarker(new JavaTokenMarker());
            }
            else if (fileName.endsWith(".make") || fileName.endsWith(".mak") || fileName.endsWith(".mk")) {
                doc.setTokenMarker(new MakefileTokenMarker());
            }
            else if (fileName.endsWith(".props") || fileName.endsWith(".properties")) {
                doc.setTokenMarker(new PropsTokenMarker());
            }
            else if (fileName.endsWith(".pl") || fileName.endsWith(".pm") || fileName.endsWith(".cgi") ) {
                doc.setTokenMarker(new PerlTokenMarker());
            }
            else if (fileName.endsWith(".php") || fileName.endsWith(".php3") || fileName.endsWith(".php4") || fileName.endsWith(".php5") || fileName.endsWith(".phtml") || fileName.endsWith(".inc") ) {
                doc.setTokenMarker(new PHPTokenMarker());
            }
            else if (fileName.endsWith(".plsql") || fileName.endsWith(".sql") ) {
                doc.setTokenMarker(new PLSQLTokenMarker());
            }
            else if (fileName.endsWith(".py")) {
                doc.setTokenMarker(new PythonTokenMarker());
            }
            else if (fileName.endsWith(".sh")) {
                doc.setTokenMarker(new ShellScriptTokenMarker());
            }
            else if (fileName.endsWith(".tsql") || fileName.endsWith(".sql")  || fileName.endsWith(".db")) {
                doc.setTokenMarker(new TSQLTokenMarker());
            }
            else if (fileName.endsWith(".tex")) {
                doc.setTokenMarker(new TeXTokenMarker());
            }
            else if (fileName.endsWith(".xml") || fileName.endsWith(".xsd") || fileName.endsWith(".xsl") || fileName.endsWith(".xslt") || fileName.endsWith(".dtd") || fileName.endsWith(".jspx") || fileName.endsWith(".library")) {
                doc.setTokenMarker(new XMLTokenMarker());
            }
        }

        void initEditor(String name, String text){
            int begin = 0;
            int end = 0;
            editor.setDocument(new SyntaxDocument());
            clone = text;
            editor.setText(text);
            doc = editor.getDocument();
            doc.addUndoableEditListener(undoHandler);
            doc.addDocumentListener(this);
            end = editor.getCaretPosition();
            //reloadModes();
            selectTockenMarker(name);
            if(path != null)
            addOpenRecentItem(path);
            resetEnabledItem(text);
            resetUndoManager();

            editor.setCaretPosition(0);
            editor.setCaretVisible(true);
            editor.setCaretBlinkEnabled(true);
            editor.repaint();
            curFont=editor.getFont();
            row=editor.getLineCount()+1;
            //System.out.println("row=" + row);
        }

        void resetEnabledItem(String text){
            boolean ispaste=false;
            cb = Toolkit.getDefaultToolkit().getSystemClipboard();
            if(cb == null){
                ispaste=false;
            }
            else ispaste=true;
            if(text.equals("")){
                selectAll.setEnabled(false);
                find.setEnabled(false);
                findnext.setEnabled(false);
                gotoline.setEnabled(false);
                gotobegin.setEnabled(false);
                gotoend.setEnabled(false);
                if(runMenu!=null)
                runMenu.setEnabled(false);
                if(macrosMenu!=null)
                macrosMenu.setEnabled(false);
            }else{
                if(macrosMenu!=null)
                macrosMenu.setEnabled(true);
                if(runMenu!=null)
                runMenu.setEnabled(true);
                selectAll.setEnabled(true);
                find.setEnabled(true);
                findnext.setEnabled(true);
                gotoline.setEnabled(true);
                gotobegin.setEnabled(true);
                gotoend.setEnabled(true);
           }
           delete.setEnabled(false);
           nonSelect.setEnabled(false);
           copy.setEnabled(false);
           cut.setEnabled(false);
           paste.setEnabled(ispaste);
        }

        void setEnabledItem(int begin, int end){
            if(begin == end){
                selectAll.setEnabled(false);
                find.setEnabled(false);
                findnext.setEnabled(false);
                gotoline.setEnabled(false);
                gotobegin.setEnabled(false);
                gotoend.setEnabled(false);
                if(runMenu!=null)
                runMenu.setEnabled(false);
                if(macrosMenu!=null)
                macrosMenu.setEnabled(false);
            }else{
                if(macrosMenu!=null)
                macrosMenu.setEnabled(true);
                if(runMenu!=null)
                runMenu.setEnabled(true);
                selectAll.setEnabled(true);
                find.setEnabled(true);
                findnext.setEnabled(true);
                gotoline.setEnabled(true);
                gotobegin.setEnabled(true);
                gotoend.setEnabled(true);
           }
           delete.setEnabled(false);
           nonSelect.setEnabled(false);
           copy.setEnabled(false);
           cut.setEnabled(false);
        }

        public void create(String name, String text) {

                initEditor(name, text);

                /*editor.setDocument(new SyntaxDocument());
                clone = text;
                editor.setText(text);
                doc = editor.getDocument();
                doc.addUndoableEditListener(undoHandler);
                doc.addDocumentListener(this);
                selectTockenMarker(name);

                setEnabledItem(text);
                resetUndoManager();

            editor.setCaretPosition(0);
            editor.setCaretVisible(true);
            editor.setCaretBlinkEnabled(true);
            editor.repaint();
            curFont=editor.getFont();
            //System.out.println("lineNumber=" + lineNumber);
            row=editor.getLineCount()+1;*/
            if (IJ.isMacOSX()) IJ.wait(25); // needed to get setCaretPosition() on OS X
                setWindowTitle(name);
                if (!macroIsInstalled &&(name.endsWith(".txt") || name.endsWith(".ijm") || name.indexOf(".")==-1)) {
                        // 'baseCount' in MacroInstaller must be updated if items are added to this menu
                        if(macrosMenu != null){mb.remove(macrosMenu);}
                        mb=getMenubar();
                        macrosMenu=createMenu("macro");
                        mb.add(macrosMenu);
                        mb.revalidate();
                        if (text.indexOf("macro ")!=-1){
                            installMacros(text, false);
                        }
                        macrosMenu.setVisible(true);
                        setEnabledItem(0, getDocLength());
                        if(runMenu != null){runMenu.setVisible(false);}
                } else if(!compilerIsInstalled && name.endsWith(".java")){
                    if(runMenu != null){mb.remove(runMenu);}
                        mb=getMenubar();
                        runMenu=createMenu("run");
                        mb.add(runMenu);
                        mb.revalidate();
                        runMenu.addSeparator();
                        JMenuItem item = createMenuItem("compileandrun", new MenuShortcut(KeyEvent.VK_R).getKey(), false);
                        runMenu.add(item);
                        runMenu.setVisible(true);
                        setEnabledItem(0, getDocLength());
                        if(macrosMenu != null){macrosMenu.setVisible(false);}
                        //compilerIsInstalled=true;
                    }else{
                        if(runMenu != null){mb.remove(runMenu);}
                        if(macrosMenu != null){mb.remove(macrosMenu);}
                        mb.revalidate();
                        mb.repaint();
                  }
                if (IJ.getInstance()!=null && !dontShowWindow)
                    setVisible(true);
                if (dontShowWindow) {
                        dispose();
                        dontShowWindow = false;
                }
                WindowManager.setWindow(this);
                //changes = false;
        }

        /**
         newTitle = getString("OpenNew...", "Title: ", newTitle);
         */
         boolean getString(String title, String prompt, String defaultString) {
                 GenericDialog gd = new GenericDialog(title, this);
                 gd.addWindowListener(this);
                 gd.addStringField(prompt, defaultString, 20);
                 gd.showDialog();
                 //System.out.println("windowClosing="+windowClosing);
                 if (gd.wasCanceled()){
                     return false;
                 }
                 fileName = gd.getNextString();
                 return true;
         }

        public void findCaretPos(){
            num=editor.getCaretLine()+1;
            length=editor.getSelectionEnd(editor.getCaretLine())-editor.getLineStartOffset(editor.getCaretLine())+1;
            setStatusLabel(num, length);
        }

        public void createMacro(String name, String text) {
                create(name, text);
                JMenuItem item = createMenuItem("converttoplugin");
                editMenu.add(item);
        }

        void installMacros(String text, boolean installInPluginsMenu) {
                installer = new MacroInstaller();
                installer.setFileName(getTitle());
                int nShortcutsOrTools = installer.install(text, macrosMenu);
                if (installInPluginsMenu || nShortcutsOrTools>0)
                        installer.install(null);
                dontShowWindow = installer.isAutoRunAndHide();
        }

        public void open(String dir, String fileName) {
                this.fileName=fileName;
                if(dir.equals("")){
                    create(fileName, "");
                    changes = false;
                    return;
                }
                path = dir+fileName;
                File file = new File(path);
                int size = (int)file.length();
                if (size>MAX_SIZE && !(IJ.isJava2()||IJ.isMacintosh())) {
                        IJ.error("This file is too large for ImageJ to open.\n"
                                +" \n"
                                +"	  File size: "+size+" bytes\n"
                                +"	  Max. size: "+MAX_SIZE+" bytes");
                        dispose();
                        return;
                }

                try {
                        sb = new StringBuilder();
                        BufferedReader r = new BufferedReader(new FileReader(file));
                        while (true) {
                                String s=r.readLine();
                                if (s==null){
                                    break;
                                }
                                else{
                                    s+="\n";
                                    sb.append(s);
                                }
                        }
                        r.close();
                        text = new String(sb);
                        create(fileName, text);
                        changes = false;
                }
                catch (Exception e) {
                        IJ.error(e.getMessage());
                        return;
                }
        }

        public String getText() {
                if (editor==null)
                        return "";
                else
                        return editor.getText();
        }
        void evaluateJavaScript() {
                if (!getTitle().endsWith(".js"))
                        setTitle(SaveDialog.setExtension(getTitle(), ".js"));
                int start = editor.getSelectionStart();
                int end = editor.getSelectionEnd();
                String text;
                if (start==end)
                        text = editor.getText();
                else
                        text = editor.getSelectedText();
                if (text.equals("")) return;
                text = getJSPrefix("") + text;
                if (IJ.isJava16() && !(IJ.isMacOSX()&&!IJ.is64Bit()))
                        IJ.runPlugIn("JavaScriptEvaluator", text);
                else {
                        Object js = IJ.runPlugIn("JavaScript", text);
                        if (js==null) IJ.error(JS_NOT_FOUND);
                }
        }


        public int getDocLength() {
            int len = editor.getDocument().getLength();
            return len;
        }

        /*public void display(String title, String text, String fileName) {
                updateForNewFile();
                String newtext = "compiler messages: "
                                 +"\nsource file: "+fileName
                                 //+"\n messages type: "+title.toLowerCase()
                                 +"\n"
                                 +"\n"+text;
                editor.setText(newtext);
                editor.setCaretPosition(0);
                editor.blinkCaret();
                editor.repaint();
                getToolbar().setVisible(false);
                setWindowTitle(title);
                changes = false;
                if (IJ.getInstance()!=null)
                        setVisible(true);
                WindowManager.setWindow(this);
        }*/

    public static void display(String title, String text, String fileName) {
            //updateForNewFile();
            String newtext = "compiler messages: "
                             +"\nsource file: "+fileName
                             //+"\n messages type: "+title.toLowerCase()
                             +"\n"
                             +"\n"+text;
            messagesEditor.setText(newtext);
            Thread timer = null;
            try {
                timer = new Thread();
                for(int i=0; i < 3; i++){
                    timer.sleep(80);
                    IJ.beep();
                }
            } catch (Exception ex) {

            }
            timer = null;
            //WindowManager.setWindow(this);
    }


        void compileAndRun() {
                if (path==null)
                        saveAs();
                if (path!=null) {
                    boolean ischanged=changes;
                    String curText = editor.getText();
                    if(ischanged){
                        save(curText);
                    }
                        IJ.runPlugIn("ij.plugin.Compiler", path);
                        if(ischanged){
                            save(clone);
                            changes = ischanged;
                        }
                }
        }

        void runMacro() {
                int start = editor.getSelectionStart();
                int end = editor.getSelectionEnd();
                String text;
                if (start==end)
                        text = editor.getText();
                else
                        text = editor.getSelectedText();
                new MacroRunner(text);
        }

        void save() {
                if (path==null) {
                        saveAs();
                        return;
                }
                File f = new File(path);
                if (f.exists() & !f.canWrite()) {
                        IJ.showMessage("Editor", "Unable to save because file is write-protected. \n \n" + path);
                        return;
                }
                String text = editor.getText();
                char[] chars = new char[text.length()];
                text.getChars(0, text.length(), chars, 0);
                try {
                        BufferedReader br = new BufferedReader(new CharArrayReader(chars));
                        BufferedWriter bw = new BufferedWriter(new FileWriter(path));
                        while (true) {
                                String s = br.readLine();
                                if (s==null) break;
                                bw.write(s, 0, s.length());
                                bw.newLine();
                        }
                        bw.close();
                        IJ.showStatus(text.length()+" chars saved to " + path);
                        changes = false;
                } catch
                        (IOException e) {}
        }

        void save(String text) {
               if (path==null) {
                       saveAs();
                       return;
               }
               File f = new File(path);
               if (f.exists() & !f.canWrite()) {
                       IJ.showMessage("Editor", "Unable to save because file is write-protected. \n \n" + path);
                       return;
               }
               char[] chars = new char[text.length()];
               text.getChars(0, text.length(), chars, 0);
               try {
                       BufferedReader br = new BufferedReader(new CharArrayReader(chars));
                       BufferedWriter bw = new BufferedWriter(new FileWriter(path));
                       while (true) {
                               String s = br.readLine();
                               if (s==null) break;
                               bw.write(s, 0, s.length());
                               bw.newLine();
                       }
                       bw.close();
                       IJ.showStatus(text.length()+" chars saved to " + path);
                       changes = false;
               } catch
                       (IOException e) {}
       }

       void saveAs() {
                String name1 = getTitle();
                if (defaultDir==null) {
                        if (name1.endsWith(".txt"))
                                defaultDir = Menus.getMacrosPath();
                        else
                                defaultDir = Menus.getPlugInsPath();
                }
                SaveDialog sd = new SaveDialog("Save Plugin As...", defaultDir, name1, null);
                String name2 = sd.getFileName();
                String dir = sd.getDirectory();
                if (name2!=null) {
                        if (name2.endsWith(".java"))
                                updateClassName(name1, name2);
                        path = dir+name2;
                        save();
                        changes = false;
                        setWindowTitle(name2);
                }
        }

        /** Changes a plugins class name to reflect a new file name. */
        public void updateClassName(String oldName, String newName) {
                if (newName.indexOf("_")<0)
                        IJ.showMessage("Plugin Editor", "Plugins without an underscore in their name will not\n"
                                +"be automatically installed when ImageJ is restarted.");
                if (oldName.equals(newName) || !oldName.endsWith(".java") || !newName.endsWith(".java"))
                        return;
                oldName = oldName.substring(0,oldName.length()-5);
                newName = newName.substring(0,newName.length()-5);
                String text1 = editor.getText();
                int index = text1.indexOf("public class "+oldName);
                if (index<0)
                        return;
                String text2 = text1.substring(0,index+13)+newName+text1.substring(index+13+oldName.length(),text1.length());
                editor.setText(text2);
        }

        void find(String s) {
                if (s==null) {
                        GenericDialog gd = new GenericDialog("Find", this);
                        gd.addStringField("Find: ", searchString, 20);
                        String[] labels = {"Case Sensitive", "Whole Words"};
                        boolean[] states = {caseSensitive, wholeWords};
                        //boolean[] states = new boolean[2];
                        //states[0]=caseSensitive; states[1]=wholeWords;
                        gd.addCheckboxGroup(1, 2, labels, states);
                        gd.showDialog();
                        if (gd.wasCanceled())
                                return;
                        s = gd.getNextString();
                        caseSensitive = gd.getNextBoolean();
                        wholeWords = gd.getNextBoolean();
                }
                if (s.equals(""))
                        return;
                String text = editor.getText();
                String s2 = s;
                if (!caseSensitive) {
                        text = text.toLowerCase(Locale.US);
                        s = s.toLowerCase(Locale.US);
                }
                int index = -1;
                if (wholeWords) {
                        int position = editor.getCaretPosition()+1;
                        while (true) {
                                index = text.indexOf(s, position);
                                if (index==-1) break;
                                if (isWholeWordMatch(text, s, index)) break;
                                position = index + 1;
                                if (position>=text.length()-1)
                                        {index=-1; break;}
                        }
                } else
                        index = text.indexOf(s, editor.getCaretPosition()+1);
                if (index<0)
                        {IJ.beep(); return;}
                editor.setSelectionStart(index);
                editor.setSelectionEnd(index+s.length());
                searchString = s2;
        }

        boolean isWholeWordMatch(String text, String word, int index) {
                char c = index==0?' ':text.charAt(index-1);
                if (Character.isLetterOrDigit(c) || c=='_') return false;
                c = index+word.length()>=text.length()?' ':text.charAt(index+word.length());
                if (Character.isLetterOrDigit(c) || c=='_') return false;
                return true;
        }

        void gotoLine() {
                GenericDialog gd = new GenericDialog("Go to Line", this);
                gd.addNumericField("Go to line number: ", lineNumber, 0);
                gd.showDialog();
                if (gd.wasCanceled())
                        return;
                int n = (int)gd.getNextNumber();
                if (n<1) return;
                String text = editor.getText();
                char[] chars = new char[text.length()];
                chars = text.toCharArray();
                int count=1, loc=0;
                for (int i=0; i<chars.length; i++) {
                        if (chars[i]=='\n') count++;
                        if (count==n)
                                {loc=i+1; break;}
                }
                num=n;
                length=1;
                setStatusLabel(num, length);
                if(n == 1)loc-=1;
                editor.setCaretPosition(loc);
                lineNumber = n;
        }


        void zapGremlins() {
                String text = editor.getText();
                char[] chars = new char[text.length()];
                chars = text.toCharArray();
                int count=0;
                boolean inQuotes = false;
                char quoteChar = 0;
                for (int i=0; i<chars.length; i++) {
                        char c = chars[i];
                        if (!inQuotes && (c=='"' || c=='\'')) {
                                inQuotes = true;
                                quoteChar = c;
                        } else  {
                                if (inQuotes && (c==quoteChar || c=='\n'))
                                inQuotes = false;
                        }
                        if (!inQuotes && c!='\n' && c!='\t' && (c<32||c>127)) {
                                count++;
                                chars[i] = ' ';
                                //IJ.log(""+(0+c));
                        }
                }
                if (count>0) {
                        text = new String(chars);
                        editor.setText(text);
                }
                if (count>0)
                        IJ.showMessage("Zap Gremlins", count+" invalid characters converted to spaces");
                else
                        IJ.showMessage("Zap Gremlins", "No invalid characters found");
        }

        void convertToPlugin() {
                if (!getTitle().endsWith(".txt")) return;
                String text = editor.getText();
                if (text==null || text.equals("")) {
                        IJ.runPlugIn("ij.plugin.NewPlugin", " ");
                        return;
                }
                if (text.indexOf("{")>-1) {
                        IJ.showMessage("Convert to Plugin", "Conversion limited to recorder generated macro code.");
                        return;
                }
                StringTokenizer st = new StringTokenizer(text, "\n");
                int n = st.countTokens();
                String line;
                StringBuffer sb = new StringBuffer();
            try {
                 for(int i=0; i<n; i++) {
                  line = st.nextToken();
                   if (line!=null && line.length()>3) {
                  sb.append("\t\tIJ.");
                  if (line.startsWith("//run"))
                          line = line.substring(2);
                  sb.append(line);
                  sb.append('\n');
                    }
                   }
                 }
                  catch (Exception ex) {
                }
                NewPlugin np = (NewPlugin)IJ.runPlugIn("ij.plugin.NewPlugin", new String(sb));
                Editor ed = np.getEditor();
                String title = getTitle();
                if (title.equals("Macro.txt"))
                        title = "Converted_Macro";
                if (title.endsWith(".txt")) title = title.substring(0, title.length()-4);
                if (title.indexOf('_')==-1) title += "_";
                title += ".java";
                ed.updateClassName(ed.getTitle(), title);
                ed.setTitle(title);
        }

        void changeFontSize(boolean larger) {
            int in = fontSize;
            if (larger) {
                fontSize++;
                if (fontSize==sizes.length)
                    fontSize = sizes.length-1;
            } else {
                fontSize--;
                if (fontSize<0)
                    fontSize = 0;
            }
            IJ.showStatus(sizes[fontSize]+" point");
            setFont();
        }

        void saveSettings() {
                    Prefs.set(FONT_SIZE, fontSize);
                    Prefs.set(FONT_MONO, monospaced.getState());
                    IJ.showStatus("Font settings saved (size="+sizes[fontSize]+", monospaced="+monospaced.getState()+")");
        }

        void setFont() {
            curFont = new Font(getFontName(), Font.PLAIN, sizes[fontSize]);
            editor.painter.setFont(curFont);
            //lineNoEditor.setFont(editor.getFont());
        }

        String getFontName() {
            return monospaced.getState()?"Monospaced":"DialogInput";
        }
        public void setFont(Font font) {
                curFont=font;
                editor.painter.setFont(font);
                fm = editor.painter.getFontMetrics(font);
        }

        public static void setDefaultDirectory(String defaultDirectory) {
                defaultDir = defaultDirectory;
        }
        void evaluateLine() {
                int start = editor.getSelectionStart();
                int end = editor.getSelectionEnd();
                if (end>start)
                        {runMacro(); return;}
                String text = editor.getText();
                while (start>0) {
                        start--;
                        if (text.charAt(start)=='\n')
                                {start++; break;}
                }
                while (end<text.length()-1) {
                        end++;
                        if (text.charAt(end)=='\n')
                                break;
                }
                editor.setSelectionStart(start);
                editor.setSelectionEnd(end);
                runMacro();
        }

        /**
         * Print the contents of the text pane using the java.awt.print API
         * Note that this API does not work efficiently in Java 1.2
         * All the hard work is done by the PrintableDocument class.
         **/
        void print() {
            // Get printable text from editor
            StyleContext sc = new StyleContext();
            DefaultStyledDocument doc = new DefaultStyledDocument(sc);
            JTextComponent printText = new JTextPane(doc);
            printText.setFont(getEditor().getFont());
            String text2Print = getEditor().getSelectedText();
            if(text2Print == null){text2Print = getEditor().getText();}
            printText.setText(text2Print);

            // Get a PrinterJob object from the system
            PrinterJob pj = PrinterJob.getPrinterJob();
            boolean pDialogState = false;
                 try {
                     PrintRequestAttributeSet aset = new HashPrintRequestAttributeSet();
                     PrintableDocument pd = new PrintableDocument(printText);
                     // Tell the PrinterJob what we want to print
                     pj.setPageable(pd);
                         pDialogState = pj.printDialog(aset);
                             if (pDialogState) {
                                    pj.print(aset);
                     }

                 } catch (java.security.AccessControlException ace) {
                     IJ.log(""+ ace);
                 }
                 catch (PrinterException e) {
                         IJ.log(""+e);
                 }
        }


        public void checkBox_itemStateChanged(ItemEvent e) {
                //JCheckBoxMenuItem item = (JCheckBoxMenuItem)e.getSource();
                  setFont();
        }

        public void setIsMacroWindow(boolean mw) {
                isMacroWindow = mw;
        }

        public void lostOwnership (Clipboard clip, Transferable cont) {}

        void textUpdate(DocumentEvent e){
            try {
                int endPos = editor.getCaretPosition();
                setEnabledItem(0, getDocLength());
                        changes = true;
                        //setEnabledItem(editor.getText());
                       if (IJ.isMacOSX()) // screen update bug work around
                        editor.setCaretPosition(endPos);

            } catch (Exception ex) {
            }
      }

      void setStatusLabel(int num, int length){
          statusLabel.setText(""+num+": "+ length+"                   ");
      }
      public static String getJSPrefix(String arg) {
              return JavaScriptIncludes+"function getArgument() {return \""+arg+"\";};";
      }

        public void insertUpdate(DocumentEvent e){
            if (isMacroWindow) return;
            textUpdate(e);
       }
       public void removeUpdate(DocumentEvent e){
           if (isMacroWindow) return;
           textUpdate(e);
           }

       public void changedUpdate(DocumentEvent e){
           if (isMacroWindow) return;
           textUpdate(e);
      }
      public boolean saveChangesDialog(){
          boolean okayToClose = true;
          ImageJ ij = IJ.getInstance();
          if (!getTitle().equals("Errors") && changes && !IJ.macroRunning() && ij!=null && !ij.quitting()) {
                  SaveChangesDialog d = new SaveChangesDialog(this, getTitle());
                  if (d.cancelPressed())
                          okayToClose = false;
                  else if (d.savePressed())
                          saveAs();
                      else if (!d.cancelPressed())
                          {changes=false; }
          }return okayToClose;
      }

      public boolean fileChanged() {
              return changes;
      }

       /** Overrides close() in PlugInFrame. */
      public void close() {
              boolean okayToClose = saveChangesDialog();
              if (okayToClose) {
                  setVisible(false);
                  dispose();
                  WindowManager.removeWindow(this);
                  nWindows--;
                  Editor.this.focusedComponent = null;
                  macroIsInstalled=false;
                  compilerIsInstalled=false;
                  isrecent=true;
              }
      }

       /** Override windowActivated in PlugInFrame to
                prevent Mac menu bar from being installed. */
        public void windowActivated(WindowEvent e) {
                WindowManager.setWindow(this);
        }

        public void windowClosing(WindowEvent e) {
                close();
        }
        public void windowOpened(WindowEvent e) {}
        public void windowClosed(WindowEvent e) {}
        public void windowIconified(WindowEvent e) {}
        public void windowDeiconified(WindowEvent e) {}
        public void windowDeactivated(WindowEvent e) {}

       /** Override  mouse listener methods*/

        public void mousePressed (MouseEvent e) {
        }
        public void mouseReleased (MouseEvent e) {
            int x=e.getX(), y=e.getY();
                /**/if (!(e.isPopupTrigger() || e.isMetaDown())){
                    if(nonSelect.isEnabled() && !isDragged){
                        editor.selectNone();
                        copy.update();
                        cut.update();
                        delete.update();
                        selectAll.setEnabled(true);
                        nonSelect.setEnabled(false);
                   }
                   isDragged = false;
                }
        }
        public void mouseEntered (MouseEvent e) {}
        public void mouseExited (MouseEvent e) {
        }
        public void mouseClicked (MouseEvent e) {
        if(!(e.isPopupTrigger() || e.isMetaDown()) && e.getClickCount() == 2) {
            if(editor.canSelect()) {
                copy.update();
                cut.update();
                delete.update();
                nonSelect.setEnabled(true);
                selectAll.setEnabled(false);
            }
        }
        }

        /** Override  mouse motionlistener methods*/
        public void mouseDragged (MouseEvent e) {
            int x=e.getX(), y=e.getY();
           if (!(e.isPopupTrigger() || e.isMetaDown())){
               if(editor.canSelect()) {
                   copy.update();
                   cut.update();
                   delete.update();
                   nonSelect.setEnabled(true);
                   selectAll.setEnabled(false);
                   isDragged = true;
               }
            }
        }
        public void mouseMoved (MouseEvent e) {}


        /** Override  mouse wheellistener method*/
        public void mouseWheelMoved(MouseWheelEvent e) {
                synchronized(this) {
                        int rot = e.getWheelRotation();
                        int rowHeight = 0;

                        if (rot<-1) rot = -1;
                        if (rot>1) rot = 1;

                        if(curRow >= 1 && curRow < row && rot == 1)
                        curRow++;
                        if(curRow > 1 && rot == -1)
                            curRow--;

                        rowHeight=fm.getHeight()+fm.getLeading();
                        rot*=rowHeight;
                        editor.getVerScrollBar().setValue(editor.getVerScrollBar().getValue()+rot);
                        if(curRow > row)curRow=row;
                        if(curRow < 1)curRow=1;
                }
        }

        /** Called once when ImageJ quits. */
        public static void savePreferences(Properties prefs) {
                int index = 0;
                int n = recentMenu.getItemCount()-2;
                for (int i=0; i<n; i++) {
                        String key = ""+i;
                        if (key.length()==1) key = "0"+key;
                        key = "recent"+key;
                        prefs.put(key, recentMenu.getItem(i).getText());
                }
                prefs.put(Prefs.MENU_SIZE, Integer.toString(fontSize));
        }


        /** Override  key listener methods*/
        public void keyPressed(KeyEvent e) {
        }
        public void keyReleased(KeyEvent e) {
      }
        public void keyTyped(KeyEvent e) {
        }

        /** Override  caret listener method*/
        public void caretUpdate(CaretEvent e){
            findCaretPos();
        }

        public void update(Graphics g){
            paint(g);
        }
        public void paint(Graphics g){
            Graphics2D g2D = (Graphics2D)g;
            this.container.repaint();
            this.getMenubar().repaint();
        }

        private static String jEditHome;
        private static String settingsDirectory;
        private static PropertyManager propMgr;
        //{{{ Property methods

        //{{{ getProperties() method
        /**
         * Returns the properties object which contains all known
         * jEdit properties. Note that as of jEdit 4.2pre10, this returns a
         * new collection, not the existing properties instance.
         * @since jEdit 3.1pre4
         */
        public static final Properties getProperties()
        {
                return propMgr.getProperties();
        } //}}}

        //{{{ getProperty() method
        /**
         * Fetches a property, returning null if it's not defined.
         * @param name The property
         */
        public static final String getProperty(String name)
        {
                return propMgr.getProperty(name);
        } //}}}

        //{{{ getProperty() method
        /**
         * Fetches a property, returning the default value if it's not
         * defined.
         * @param name The property
         * @param def The default value
         */
        public static final String getProperty(String name, String def)
        {
                String value = propMgr.getProperty(name);
                if(value == null)
                        return def;
                else
                        return value;
        } //}}}

        //{{{ getProperty() method
        /**
         * Returns the property with the specified name.<p>
         *
         * The elements of the <code>args</code> array are substituted
         * into the value of the property in place of strings of the
         * form <code>{<i>n</i>}</code>, where <code><i>n</i></code> is an index
         * in the array.<p>
         *
         * You can find out more about this feature by reading the
         * documentation for the <code>format</code> method of the
         * <code>java.text.MessageFormat</code> class.
         *
         * @param name The property
         * @param args The positional parameters
         */
        public static final String getProperty(String name, Object[] args)
        {
                if(name == null)
                        return null;
                if(args == null)
                        return getProperty(name);
                else
                {
                        String value = getProperty(name);
                        if(value == null)
                                return null;
                        else
                                return java.text.MessageFormat.format(value,args);
                }
        } //}}}
        //{{{ reloadModes() method
        /**
         * Reloads all edit modes.
         * @since jEdit 3.2pre2
         */
        public static void reloadModes()
        {
                /* Try to guess the eventual size to avoid unnecessary
                 * copying */
                modes = new Vector(50);
                jEditHome = System.getProperty("user.dir");
                settingsDirectory = ".jedit";

                //{{{ Load the global catalog
                if(jEditHome == null){
                        loadModeCatalog("/modes/catalog",true);
                }
                else
                {
                        loadModeCatalog(MiscUtilities.constructPath(jEditHome,
                                "modes","catalog"),false);
                } //}}}

                //{{{ Load user catalog
                if(settingsDirectory != null)
                {
                        File userModeDir = new File(MiscUtilities.constructPath(
                                settingsDirectory,"modes"));
                        if(!userModeDir.exists())
                                userModeDir.mkdirs();

                        File userCatalog = new File(MiscUtilities.constructPath(
                                settingsDirectory,"modes","catalog"));
                        if(!userCatalog.exists())
                        {
                                // create dummy catalog
                                FileWriter out = null;
                                try
                                {
                                        out = new FileWriter(userCatalog);
                                        out.write(Editor.getProperty("defaultCatalog"));
                                        out.close();
                                }
                                catch(IOException io)
                                {
                                        Log.log(Log.ERROR,Editor.class,io);
                                }
                                finally
                                {
                                        try
                                        {
                                                if(out != null)
                                                        out.close();
                                        }
                                        catch(IOException e)
                                        {
                                        }
                                }
                        }

                        loadModeCatalog(userCatalog.getPath(),false);
                } //}}}

               /* Buffer buffer = buffersFirst;
                while(buffer != null)
                {
                        // This reloads the token marker and sends a message
                        // which causes edit panes to repaint their text areas
                        buffer.setMode();

                        buffer = buffer.next;
                }*/
        } //}}}

        private static void loadModeCatalog(String path, boolean resource)
        {
                Log.log(Log.MESSAGE,Editor.class,"Loading mode catalog file " + path);

                ModeCatalogHandler handler = new ModeCatalogHandler(
                        MiscUtilities.getParentOfPath(path),resource);
                XmlParser parser = new XmlParser();
                parser.setHandler(handler);
                java.io.Reader in = null;
                try
                {
                        java.io.InputStream _in;
                        if(resource)
                                _in = Editor.class.getResourceAsStream(path);
                        else
                                _in = new java.io.FileInputStream(path);
                        in = new BufferedReader(new java.io.InputStreamReader(_in));
                        parser.parse(null, null, in);
                }
                catch(XmlException xe)
                {
                        int line = xe.getLine();
                        String message = xe.getMessage();
                        Log.log(Log.ERROR,Editor.class,path + ":" + line
                                + ": " + message);
                }
                catch(Exception e)
                {
                        Log.log(Log.ERROR,Editor.class,e);
                }
                finally
                {
                        try
                        {
                                if(in != null)
                                        in.close();
                        }
                        catch(IOException io)
                        {
                                Log.log(Log.ERROR,Editor.class,io);
                        }
                }
} //}}}
            //{{{ addMode() method
        /**
         * Do not call this method. It is only public so that classes
         * in the org.gjt.sp.jedit.syntax package can access it.
         * @param mode The edit mode
         */
        public static void addMode(Mode mode)
        {
                //Log.log(Log.DEBUG,jEdit.class,"Adding edit mode "
                //	+ mode.getName());

                modes.addElement(mode);
        } //}}}
        //{{{ getMode() method
        /**
         * Returns the edit mode with the specified name.
         * @param name The edit mode
         */
        public static Mode getMode(String name)
        {
                for(int i = 0; i < modes.size(); i++)
                {
                        Mode mode = (Mode)modes.elementAt(i);
                        if(mode.getName().equals(name))
                                return mode;
                }
                return null;
        } //}}}
        //{{{ getModes() method
        /**
         * Returns an array of installed edit modes.
         */
        public static Mode[] getModes()
        {
                Mode[] array = new Mode[modes.size()];
                modes.copyInto(array);
                return array;
        } //}}}

        //}}}
        public static void loadMode(Mode mode)
        {
                final String fileName = (String)mode.getProperty("file");

                Log.log(Log.NOTICE,Editor.class,"Loading edit mode " + fileName);

                final XmlParser parser = new XmlParser();
                XModeHandler xmh = new XModeHandler(mode.getName())
                {
                        public void error(String what, Object subst)
                        {
                                int line = parser.getLineNumber();
                                int column = parser.getColumnNumber();

                                String msg="";

                                /**/if(subst == null)
                                        msg = Editor.getProperty("xmode-error." + what);
                                else
                                {
                                        msg = Editor.getProperty("xmode-error." + what,
                                                new String[] { subst.toString() });
                                        if(subst instanceof Throwable)
                                                Log.log(Log.ERROR,this,subst);
                                }

                                Object[] args = { fileName, new Integer(line),
                                        new Integer(column), msg };
                                //GUIUtilities.error(null,"xmode-error",args);
                        }

                        public ij.plugin.frame.jedit.syntax.TokenMarker getTokenMarker(String modeName)
                        {
                                Mode mode = getMode(modeName);
                                if(mode == null)
                                        return null;
                                else
                                        return mode.getTokenMarker();
                        }
                };

                mode.setTokenMarker(xmh.getTokenMarker());

                java.io.Reader grammar = null;

                parser.setHandler(xmh);
                try
                {
                        grammar = new BufferedReader(new FileReader(fileName));

                        parser.parse(null, null, grammar);

                        mode.setProperties(xmh.getModeProperties());
                }
                catch (Throwable e)
                {
                        Log.log(Log.ERROR, Editor.class, e);

                        if (e instanceof XmlException)
                        {
                                XmlException xe = (XmlException) e;
                                int line = xe.getLine();
                                String message = xe.getMessage();

                                Object[] args = { fileName, new Integer(line), null,
                                        message };
                                IJ.error("xmode-error",(String)args[0]);
                        }
                }
                finally
                {
                        try
                        {
                                if(grammar != null)
                                        grammar.close();
                        }
                        catch(IOException io)
                        {
                                Log.log(Log.ERROR,Editor.class,io);
                        }
                }
        } //}}}

        /**
         * Suffix applied to the key used in resource file
         * lookups for an button enabled.
         */
        public static final String undoSuffix = "Enabled";

        /**
         * Suffix applied to the key used in resource file
         * lookups for an image.
         */
        public static final String imageSuffix = "Image";

        /**
         * Suffix applied to the key used in resource file
         * lookups for a label.
         */
        public static final String labelSuffix = "Label";

        /**
         * Suffix applied to the key used in resource file
         * lookups for an action.
         */
        public static final String actionSuffix = "Action";

        /**
         * Suffix applied to the key used in resource file
         * lookups for tooltip text.
         */

        public static final String tipSuffix = "Tooltip";

        public static final String cutAction = "cut";
        public static final String copyAction = "copy";
        public static final String pasteAction = "paste";
        public static final String deleteAction = "delete";
        public static final String editAction = "edit";
        public static final String selectAllAction = "selectall";
        public static final String nonSelectAction = "nonselect";
        public static final String openAction = "open";
        public static final String newAction  = "new";
        public static final String saveAction = "save";
        public static final String saveAsAction = "save-as";
        public static final String findAction = "find";
        public static final String findnextAction = "findnext";
        public static final String gotobeginlineAction = "gotobeginline";
        public static final String gotoendlineAction = "gotoendline";
        public static final String gotolineAction = "gotoline";
        public static final String compileandrunAction = "compileandrun";
        public static final String runappAction = "runapp";
        public static final String printAction = "print";
        public static final String exitAction = "exit";
        public static final String savesettingsAction = "savesettings";
        public static final String monospacedAction = "monospaced";
        public static final String smalerAction = "smaler";
        public static final String largerAction = "larger";
        public static final String runmacroAction = "runmacro";
        public static final String evaluatelineAction = "evaluateline";
        public static final String abortmacroAction = "abortmacro";
        public static final String installmacrosAction = "installmacros";

        // --- action implementations -----------------------------------

        /**
         * Listener for the edits on the current document.
         */
        protected UndoableEditListener undoHandler = new UndoHandler();

        /** UndoManager that we add edits to. */
        protected UndoManager undo = new UndoManager();
        private UndoAction undoAction = new UndoAction();
        private RedoAction redoAction = new RedoAction();
        private CopyAction copy = new CopyAction();
        private CutAction cut = new CutAction();
        private PasteAction paste = new PasteAction();
        private SelectAllAction selectAll = new SelectAllAction();
        private SelectNoneAction nonSelect = new SelectNoneAction();
        private DeleteAction delete = new DeleteAction();
        private EditAction edit = new EditAction();
        private CompileAndRunAction compileAndRun = new CompileAndRunAction();
        private FindAction find = new FindAction();
        private FindNextAction findnext = new FindNextAction();
        private GoToLineAction gotoline = new GoToLineAction();
        private GoToBeginLineAction gotobegin = new GoToBeginLineAction();
        private GoToEndLineAction gotoend = new GoToEndLineAction();

        /**
        * Actions defined by the Editor class
        */
       private Action[] defaultActions = {
                                         copy,
                                         cut,
                                         paste,
                                         selectAll,
                                         delete,
                                         nonSelect,
                                         edit,
                                         new NewAction(),
                                         new OpenAction(),
                                         new SaveAction(),
                                         new SaveAsAction(),
                                         new PrintAction(),
                                         new ExitAction(),
                                         new SmalerAction(),
                                         find,
                                         findnext,
                                         gotoline,
                                         gotobegin,
                                         gotoend,
                                         new LargerAction(),
                                         new MonospacedAction(),
                                         new SaveSettingsAction(),
                                         compileAndRun,
                                         new RunAppAction(),
                                         new RunMacroAction(),
                                         new EvaluateLineAction(),
                                         new AbortMacrosAction(),
                                         new InstallMacroAction(),
                                         undoAction,
                                         redoAction
       };

       class UndoHandler implements UndoableEditListener {

            /**
             * Messaged when the Document has created an edit, the edit is
             * added to <code>undo</code>, an instance of UndoManager.
             */
            public void undoableEditHappened(UndoableEditEvent e) {
                undo.addEdit(e.getEdit());
                undoAction.update();
                redoAction.update();
            }
        }
        class OpenAction extends NewAction {

            OpenAction() {
                super(openAction);
            }

            public void actionPerformed(ActionEvent e) {
                saveChangesDialog();
                //JFrame[] editFrame = WindowManager.getNonImageWindows();
                //for(int i=0; i < editFrame.length; i++){
                    //IJ.log("" + editFrame[i].getClass().getName());
                  //  if (editFrame[i].getClass().getName().equals("ij.plugin.frame.Editor")){
                  //      editFrame[i].setVisible(false);
                  //      WindowManager.removeWindow(editFrame[i]);
                  //  }
                  //}
                IJ.open();
            }
        }

        class CopyAction extends AbstractAction {

            CopyAction() {
                super(copyAction);
            }

            public void actionPerformed(ActionEvent e) {
                editor.copy();
                //cut.setEnabled(false);
                delete.setEnabled(true);
                paste.setEnabled(true);
                //this.setEnabled(false);
            }
            protected void update() {
               if(editor.canSelect()) {
                   setEnabled(true);
                   //putValue(Action.NAME, "Copy");//undo.getRedoPresentationName());
               }
               else {
                   setEnabled(false);
                   //putValue(Action.NAME, "Copy");
               }
           }
       }

        class CutAction extends AbstractAction {

            CutAction() {
                super(cutAction);
            }

            public void actionPerformed(ActionEvent e) {
                editor.cut();
                copy.setEnabled(false);
                delete.setEnabled(false);
                nonSelect.setEnabled(false);
                selectAll.setEnabled(true);
                paste.setEnabled(true);
                this.setEnabled(false);
                setEnabledItem(0, getDocLength());
            }
            protected void update() {
              if(editor.canSelect()) {
                  setEnabled(true);
                  //putValue(Action.NAME, "Cut");//undo.getRedoPresentationName());
              }
              else {
                  setEnabled(false);
                  //putValue(Action.NAME, "Cut");
              }
          }
       }

        class PasteAction extends AbstractAction {

            PasteAction() {
                super(pasteAction);
            }

            public void actionPerformed(ActionEvent e) {
                editor.paste();
                editor.selectNone();
                copy.update();
                cut.update();
                if(delete.isEnabled()){
                    delete.setEnabled(false);
                }
                if(nonSelect.isEnabled()){
                    nonSelect.setEnabled(false);
                }
                setEnabledItem(0, getDocLength());
            }
            protected void update() {
               if(editor.canSelect()) {
                   setEnabled(true);
                   //putValue(Action.NAME, "Paste");//undo.getRedoPresentationName());
               }
               else {
                   setEnabled(false);
                   //putValue(Action.NAME, "Paste");
               }
           }
        }


        class DeleteAction extends AbstractAction {

            DeleteAction() {
                super(deleteAction);
            }

            public void actionPerformed(ActionEvent e) {
                editor.setSelectedText("");
                if(editor.getText().equals("")){
                    selectAll.setEnabled(false);
                }else{
                    selectAll.setEnabled(true);
               }
                copy.setEnabled(false);
               cut.setEnabled(false);
               delete.setEnabled(false);
               nonSelect.setEnabled(false);
               this.setEnabled(false);
               setEnabledItem(0, getDocLength());
           }
            protected void update() {
               if(editor.canSelect()) {
                   setEnabled(true);
                   //putValue(Action.NAME, "Paste");//undo.getRedoPresentationName());
               }
               else {
                   setEnabled(false);
                   //putValue(Action.NAME, "Paste");
               }
           }
        }
        class SelectAllAction extends AbstractAction {

            SelectAllAction() {
                super(selectAllAction);
            }

            public void actionPerformed(ActionEvent e) {
                editor.selectAll();
                copy.setEnabled(true);
                cut.setEnabled(true);
                delete.setEnabled(true);
                nonSelect.setEnabled(true);
                this.setEnabled(false);
           }
            protected void update() {
                if (editor.canSelect()) {
                    setEnabled(true);
                    //putValue(Action.NAME, "Paste");//undo.getRedoPresentationName());
                } else {
                    setEnabled(false);
                    //putValue(Action.NAME, "Paste");
                }
            }
       }

        class SelectNoneAction extends AbstractAction {

            SelectNoneAction() {
                super(nonSelectAction);
            }

            public void actionPerformed(ActionEvent e) {
                editor.selectNone();
                copy.setEnabled(false);
                cut.setEnabled(false);
                delete.setEnabled(false);
                selectAll.setEnabled(true);
                this.setEnabled(false);
            }
        }

        class SaveAction extends AbstractAction {

            SaveAction() {
                super(saveAction);
            }

            public void actionPerformed(ActionEvent e) {
                save();
            }
        }

        class SaveAsAction extends AbstractAction {

            SaveAsAction() {
                super(saveAsAction);
            }

            public void actionPerformed(ActionEvent e) {
                saveAs();
            }
        }

        class NewAction extends AbstractAction {

            NewAction() {
                super(newAction);
            }

            NewAction(String nm) {
                super(nm);
            }

            public void actionPerformed(ActionEvent e) {
                saveChangesDialog();
                if(fileName==null)return;
                int dot = fileName.lastIndexOf(".");
                String endWith = fileName.substring(dot, fileName.length());
                fileName="Untitled"+endWith;
                boolean isShowing = getString("Open New...", "Document Title: ", fileName);
                if(!isShowing)
                return;
                create(fileName, "");
                setWindowTitle(fileName);
                changes=false;
                editor.repaint();
            }
        }
        /**
         * Really lame implementation of an begin to edit command
         */
        class EditAction extends AbstractAction {

            EditAction() {
                super(editAction);
            }

            public void actionPerformed(ActionEvent e) {
                //editor.setCaretPosition(0);
            }
        }
        /**
         * Really lame implementation of an print command
         */
        class PrintAction extends AbstractAction {

            PrintAction() {
                super(printAction);
            }

            public void actionPerformed(ActionEvent e) {
                print();
            }
        }
        /**
         * Really lame implementation of an exit command
         */
        class ExitAction extends AbstractAction {

            ExitAction() {
                super(exitAction);
            }

            public void actionPerformed(ActionEvent e) {
                close();
            }
        }
        /**
         * Really lame implementation of an smalerfont command
         */
        class SmalerAction extends AbstractAction {

            SmalerAction() {
                super(smalerAction);
            }

            public void actionPerformed(ActionEvent e) {
                changeFontSize(false);
            }
        }
        /**
         * Really lame implementation of an find text command
         */
        class FindAction extends AbstractAction {

            FindAction() {
                super(findAction);
            }

            public void actionPerformed(ActionEvent e) {
                find(null);
            }
        }
        /**
         * Really lame implementation of an find next text command
         */
        class FindNextAction extends AbstractAction {

            FindNextAction() {
                super(findnextAction);
            }

            public void actionPerformed(ActionEvent e) {
                find(searchString);
            }
        }
        /**
         * Really lame implementation of an go to line command
         */
        class GoToLineAction extends AbstractAction {

            GoToLineAction() {
                super(gotolineAction);
            }

            public void actionPerformed(ActionEvent e) {
                gotoLine();
            }
        }
        /**
         * Really lame implementation of an go to begin line command
         */
        class GoToBeginLineAction extends AbstractAction {

            GoToBeginLineAction() {
                super(gotobeginlineAction);
            }

            public void actionPerformed(ActionEvent e) {
                editor.setCaretPosition(0);
            }
        }
        /**
         * Really lame implementation of an go to end line command
         */
        class GoToEndLineAction extends AbstractAction {

            GoToEndLineAction() {
                super(gotoendlineAction);
            }

            public void actionPerformed(ActionEvent e) {
                editor.setCaretPosition(doc.getLength());
            }
        }
        /**
         * Really lame implementation of an lager font command
         */
        class LargerAction extends AbstractAction {

            LargerAction() {
                super(largerAction);
            }

            public void actionPerformed(ActionEvent e) {
                changeFontSize(true);
            }
        }
        /**
         * Really lame implementation of an monospaced font command
         */
        class MonospacedAction extends AbstractAction {

            MonospacedAction() {
                super(monospacedAction);
            }

            public void actionPerformed(ActionEvent e) {
                setFont();
            }
        }
        /**
         * Really lame implementation of an save settings font command
         */
        class SaveSettingsAction extends AbstractAction {

           SaveSettingsAction() {
                super(savesettingsAction);
            }

            public void actionPerformed(ActionEvent e) {
                print();
            }
        }
        /**
         * Really lame implementation of an compile and run command
         */
        class RunAppAction extends AbstractAction {

           RunAppAction() {
                super(runappAction);
            }

            public void actionPerformed(ActionEvent e) {
                //
            }
        }
        /**
         * Really lame implementation of an compile and run command
         */
        class CompileAndRunAction extends AbstractAction {

           CompileAndRunAction() {
                super(compileandrunAction);
            }

            public void actionPerformed(ActionEvent e) {
                compileAndRun();
            }
        }
        /**
         * Really lame implementation of an compile and run command
         */
        class RunMacroAction extends AbstractAction {

           RunMacroAction() {
                super(runmacroAction);
            }

            public void actionPerformed(ActionEvent e) {
                runMacro();
            }
        }
        /**
         * Really lame implementation of an compile and run command
         */
        class EvaluateLineAction extends AbstractAction {

           EvaluateLineAction() {
                super(evaluatelineAction);
            }

            public void actionPerformed(ActionEvent e) {
                                evaluateLine();
            }
        }
        /**
         * Really lame implementation of an compile and run command
         */
        class AbortMacrosAction extends AbstractAction {

           AbortMacrosAction() {
                super(abortmacroAction);
            }

            public void actionPerformed(ActionEvent e) {
                Interpreter.abort();
                IJ.beep();
            }
        }
        /**
         * Really lame implementation of an compile and run command
         */
        class InstallMacroAction extends AbstractAction {

           InstallMacroAction() {
                super(installmacrosAction);
            }

            public void actionPerformed(ActionEvent e) {
                installMacros(editor.getText(), true);
            }
        }
        class UndoAction extends AbstractAction {
            public UndoAction() {
                super("Undo");
                setEnabled(false);
            }

            public void actionPerformed(ActionEvent e) {
                try {
                    undo.undo();
                } catch (CannotUndoException ex) {
                    System.out.println("Unable to undo: " + ex);
                    ex.printStackTrace();
                }
                update();
                redoAction.update();
                setEnabledItem(0, getDocLength());
            }

            protected void update() {
                if(undo.canUndo()) {
                    setEnabled(true);
                    putValue(Action.NAME, "Undo");//undo.getUndoPresentationName());
                }
                else {
                    setEnabled(false);
                    putValue(Action.NAME, "Undo");
                }
            }
        }

        class RedoAction extends AbstractAction {
            public RedoAction() {
                super("Redo");
                setEnabled(false);
            }

            public void actionPerformed(ActionEvent e) {
                try {
                    undo.redo();
                } catch (CannotRedoException ex) {
                    System.out.println("Unable to redo: " + ex);
                    ex.printStackTrace();
                }
                update();
                undoAction.update();
                setEnabledItem(0, getDocLength());
            }

            protected void update() {
                if(undo.canRedo()) {
                    setEnabled(true);
                    putValue(Action.NAME, "Redo");//undo.getRedoPresentationName());
                }
                else {
                    setEnabled(false);
                    putValue(Action.NAME, "Redo");
                }
            }
        }

        class ColoredSquare implements Icon {
            Color color;
            public ColoredSquare(Color c) {
                this.color = c;
            }

            public void paintIcon(Component c, Graphics g, int x, int y) {
                Color oldColor = g.getColor();
                g.setColor(color);
                g.fill3DRect(x,y,getIconWidth(), getIconHeight(), true);
                g.setColor(oldColor);
            }
            public int getIconWidth() { return 12; }
            public int getIconHeight() { return 12; }

        }

        class FocusHandler implements FocusListener
        {
                public void focusGained(FocusEvent evt)
                {
                        editor.setCaretVisible(true);
                        //System.out.println("evt.getClass().getName()=" + evt.getClass().getName());
                        JEditTextArea.focusedComponent = editor;
                }

                public void focusLost(FocusEvent evt)
                {
                        editor.setCaretVisible(false);
                        JEditTextArea.focusedComponent = null;
                }
        }
        public static Editor getInstance() {
                return focusedComponent;
        }

}

