package ij2x;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Color;
import java.awt.Dimension;

import java.net.URL;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.Icon;
import javax.swing.border.BevelBorder;
import javax.swing.BorderFactory;
import javax.swing.border.Border;

import ij.IJ;
import ij.ImageJ;
import ij.ImagePlus;
import ij.Prefs;
import ij.WindowManager;
import ij.util.Tools;
import ij.plugin.PlugIn;
import ij2x.plugin.imageborder.ImageBorderPanel;
import javax.swing.WindowConstants;
import java.awt.Image;
import java.awt.event.WindowEvent;
import java.text.DateFormat;
import java.awt.event.WindowListener;
import java.awt.Point;
import javax.swing.JFrame;
import java.awt.Container;
import java.awt.Toolkit;


/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class Math_Commands_Bar extends JPanel implements PlugIn, ActionListener, MouseListener, MouseMotionListener {

    protected ImagePlus imp;
    protected ImageJ ij;
    public JButton infoButton, draggedButton, closeButton, undecoratedButton;
    protected JButton addButton, subButton, mulButton, divButton, orButton, andButton
            , xorButton, minButton, maxButton, gammaButton, calculButton ;
    private JButton action;
    private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    private Border lightGrayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.lightGray, Color.lightGray);
    private int actionCount = 0;
    private static int current;
    private long mouseDownTime;
    public static final int DOUBLE_CLICK_THRESHOLD = 150;
    public JPanel controlBarPanel=new JPanel();
    public JPanel panel=new JPanel();
    private GridBagLayout gblayout = new GridBagLayout();
    private static String fileType = ".gif";
    private static String dir;
    static final String LOC_KEY = "mtbf.loc";

    public Math_Commands_Bar() {
        ij = IJ.getInstance();
    }
    public void run(String arg){
        ij = IJ.getInstance();
        controlBarPanel=createMathCommandsBar();
        Dimension ijsize = ij.getSize();
        Dimension cbpsize = controlBarPanel.getPreferredSize();
        Dimension cbp2ijSize = new Dimension((int)ijsize.getWidth()-6, (int)cbpsize.getHeight());

        final JFrame stframe = new JFrame("Math Commands Bar");
        Container container = stframe.getContentPane();
        container.setMinimumSize(cbp2ijSize);
        container.setPreferredSize(cbp2ijSize);
        container.setMaximumSize(cbp2ijSize);
        stframe.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        stframe.addWindowListener(new WindowListener(){
                public void windowClosing(WindowEvent e) {
                    if (e.getSource()==stframe) {
                        stframe.dispose();
                        //stframe.setVisible(false);
                Prefs.saveLocation(LOC_KEY, stframe.getLocation());
                //IJ.notifyEventListeners(IJEventListener.COLOR_PICKER_CLOSED);
                        WindowManager.removeWindow(stframe);
                    }
                }

                public void windowActivated(WindowEvent e) {
                            if (IJ.isMacintosh() && IJ.getInstance()!=null) {
                                    IJ.wait(10); // may be needed for Java 1.4 on OS X
                            }
                            WindowManager.setWindow(stframe);
                    }

                public void windowOpened(WindowEvent e) {}
                public void windowClosed(WindowEvent e) {}
                public void windowIconified(WindowEvent e) {}
                public void windowDeiconified(WindowEvent e) {}
                public void windowDeactivated(WindowEvent e) {}

        });
        if (ij!=null) {
                Image img = ij.getIconImage();
                if (img!=null)
                        try {stframe.setIconImage(img);} catch (Exception e) {}
        }
              container .add(controlBarPanel);
              stframe.setResizable(false);
              stframe.pack();
                Point loc = Prefs.getLocation(LOC_KEY);
                if (loc!=null)
                        stframe.setLocation(loc);
                else
                        stframe.setLocation(new Point(ij.getLocation().x,  (int)ijsize.getHeight()));
              stframe.setVisible(true);

    }

    public JPanel createMathCommandsBar(){

        java.awt.FlowLayout flayout = new java.awt.FlowLayout(java.awt.FlowLayout.CENTER);
        flayout.setHgap(0);
        flayout.setVgap(0);
        panel.setLayout(flayout);
        panel.setBorder(lightGrayBorder);
        dir = Prefs.getString("icondir");
        infoButton=createButton(infoButton, "Show Info ...");
        infoButton.setIcon(createIcon("s_info"));
        infoButton.setRolloverIcon(createIcon("s_info_ro"));
        infoButton.setPressedIcon(createIcon("s_info_press"));
        addButton=createButton(addButton, "Add Dyadic Image");
        addButton.setIcon(createIcon("mathimages/s_add"));
        addButton.setRolloverIcon(createIcon("mathimages/s_add_ro"));
        addButton.setPressedIcon(createIcon("mathimages/s_add_press"));
        subButton=createButton(subButton, "Sub Dyadic Image");
        subButton.setIcon(createIcon("mathimages/s_sub"));
        subButton.setRolloverIcon(createIcon("mathimages/s_sub_ro"));
        subButton.setPressedIcon(createIcon("mathimages/s_sub_press"));
        mulButton=createButton(mulButton, "Mul Dyadic Image");
        mulButton.setIcon(createIcon("mathimages/s_mul"));
        mulButton.setRolloverIcon(createIcon("mathimages/s_mul_ro"));
        mulButton.setPressedIcon(createIcon("mathimages/s_mul_press"));
        divButton=createButton(divButton, "Div Dyadic Image");
        divButton.setIcon(createIcon("mathimages/s_div"));
        divButton.setRolloverIcon(createIcon("mathimages/s_div_ro"));
        divButton.setPressedIcon(createIcon("mathimages/s_div_press"));
        minButton=createButton(minButton, "Min Dyadic Image");
        minButton.setIcon(createIcon("mathimages/s_min"));
        minButton.setRolloverIcon(createIcon("mathimages/s_min_ro"));
        minButton.setPressedIcon(createIcon("mathimages/s_min_press"));
        maxButton=createButton(maxButton, "Max Dyadic Image");
        maxButton.setIcon(createIcon("mathimages/s_max"));
        maxButton.setRolloverIcon(createIcon("mathimages/s_max_ro"));
        maxButton.setPressedIcon(createIcon("mathimages/s_max_press"));
        gammaButton=createButton(gammaButton, "Gamma Image");
        gammaButton.setIcon(createIcon("mathimages/s_gamma"));
        gammaButton.setRolloverIcon(createIcon("mathimages/s_gamma_ro"));
        gammaButton.setPressedIcon(createIcon("mathimages/s_gamma_press"));
        orButton=createButton(orButton, "Or Dyadic Image");
        orButton.setIcon(createIcon("mathimages/s_or"));
        orButton.setRolloverIcon(createIcon("mathimages/s_or_ro"));
        orButton.setPressedIcon(createIcon("mathimages/s_or_press"));
        andButton=createButton(andButton, "And Dyadic Image");
        andButton.setIcon(createIcon("mathimages/s_and"));
        andButton.setRolloverIcon(createIcon("mathimages/s_and_ro"));
        andButton.setPressedIcon(createIcon("mathimages/s_and_press"));
        xorButton=createButton(xorButton, "Xor Image");
        xorButton.setIcon(createIcon("mathimages/s_xor"));
        xorButton.setRolloverIcon(createIcon("mathimages/s_xor_ro"));
        xorButton.setPressedIcon(createIcon("mathimages/s_xor_press"));
        calculButton=createButton(calculButton, "Image Calculator");
        calculButton.setIcon(createIcon("mathimages/process/s_calcul"));
        calculButton.setRolloverIcon(createIcon("mathimages/process/s_calcul_ro"));
        calculButton.setPressedIcon(createIcon("mathimages/process/s_calcul_press"));

        draggedButton = createButton(draggedButton, "Move Button");
        draggedButton.setIcon(createIcon("newplayer/player_a_08"));
        draggedButton.setPressedIcon(createIcon("newplayer/player_a_08_press"));
        draggedButton.setRolloverIcon(createIcon("newplayer/player_a_08_rolover"));
        closeButton = createButton(closeButton, "Decorated Button");
        closeButton.setIcon(createIcon("newplayer/player_a_09"));
        closeButton.setPressedIcon(createIcon("newplayer/player_a_09_press"));
        closeButton.setRolloverIcon(createIcon("newplayer/player_a_09_rolover"));
        undecoratedButton = createButton(undecoratedButton, "Undecorated Button");
        undecoratedButton.setIcon(createIcon("newplayer/player_a_10"));
        undecoratedButton.setPressedIcon(createIcon("newplayer/player_a_10_press"));
        undecoratedButton.setRolloverIcon(createIcon("newplayer/player_a_10_rolover"));

        panel.add(calculButton);
        panel.add(addButton);
        panel.add(subButton);
        panel.add(mulButton);
        panel.add(divButton);
        panel.add(andButton);
        panel.add(orButton);
        panel.add(xorButton);
        panel.add(minButton);
        panel.add(maxButton);
        panel.add(gammaButton);
        panel.add(infoButton);

        return panel;
     }
     private JButton createButton(JButton action, String tooltip){
         action = new JButton();
            action.setToolTipText(tooltip);
             action.addActionListener(this);
           action.addMouseListener(this);
          action.addMouseMotionListener(this);
         setBorderlessButton(action);
     return action;
     }

     private Icon createIcon(String key){
         Icon icon = null;
         String fileName=key + getFileType();
         if(getImageDir() == null){
            dir="images/mathimages/";
         }
         String path = getImageDir()+fileName;
        try {
            URL url = this.getClass().getResource(path);
            Image image = Toolkit.getDefaultToolkit().createImage(url);
            if (url != null) {
                icon = new ImageIcon(image);
            }
        } catch (Exception ex) {
        }
     return icon;
     }
     private String getFileType(){
           return fileType;
     }
     private String getImageDir(){
           return dir;
     }
     private void setIcon(JButton action, Image[] image){
         action.setIcon(new ImageIcon(image[0]));
           action.setRolloverIcon(new ImageIcon(image[1]));
         action.setPressedIcon(new ImageIcon(image[2]));
     }


     void setButtonDim(JButton action, Dimension maxDim, Dimension preDim, Dimension minDim){
       action.setMaximumSize(maxDim);
          action.setPreferredSize(preDim);
       action.setMinimumSize(minDim);
   }

     void setBorderlessButton(JButton button){
           button.setMargin(new Insets(0, 0, 0, 0));
              button.setBorderPainted(false);
              button.setContentAreaFilled(false);
           button.setFocusPainted(false);
       }


       public void setMoviePanel(boolean isMoviepanel){
       //movieJPanel.setVisible(isMoviepanel);
       }

       public void setButtonPanel(boolean isButtonpanel){
       //panel.setVisible(isButtonpanel);
       }

       public void mousePressed(MouseEvent e) {
           action = (JButton)e.getSource();
           int x = e.getX();
           boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
           mouseDownTime = System.currentTimeMillis();
                if (!doubleClick) {
                }
        }

        public void mouseReleased(MouseEvent e) {}
        public void mouseExited(MouseEvent e) {}
        public void mouseClicked(MouseEvent e) {}
        public void mouseEntered(MouseEvent e) {}

        public void mouseDragged(MouseEvent e) {}
        public void mouseMoved(MouseEvent e) {
            JButton action = (JButton)e.getSource();
            int x = e.getX();
            boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
            mouseDownTime = System.currentTimeMillis();
                 if (!false) {
                     if(action == infoButton){
                         IJ.showStatus("Command: Show Info...");
                     }
                     else if(action == addButton){
                         IJ.showStatus("Command: Add...");
                     }
                     else if(action == subButton){
                         IJ.showStatus("Command: Sub...");
                     }
                     else if(action == mulButton){
                         IJ.showStatus("Command: Mul...");
                     }
                     else if(action == divButton){
                         IJ.showStatus("Command: Div...");
                     }
                     else if(action == andButton){
                         IJ.showStatus("Command: And...T");
                     }
                     else if(action == orButton){
                         IJ.showStatus("Command: Or...");
                     }
                     else if(action == xorButton){
                         IJ.showStatus("Command: Xor...");
                     }
                     else if(action == minButton){
                         IJ.showStatus("Command: Min...");
                     }
                     else if(action == maxButton){
                         IJ.showStatus("Command: Max...");
                     }
                     else if (action == draggedButton) {
                         IJ.showStatus("Move...");
                     }
                     else if (action == closeButton) {
                         IJ.showStatus("Decorated Frame");
                     }
                     else if (action == undecoratedButton) {
                         IJ.showStatus("Undecorated Frame");
                     }
                     else if(action == gammaButton){
                         IJ.showStatus("Command: Gamma...");
                     }
                     else if(action == calculButton){
                         IJ.showStatus("Command: ImageCalculator...");
                     }

                 }
        }
        public void actionPerformed(ActionEvent e){
            try {
                if(action == infoButton){
                    IJ.doCommand("Show Info...");
                }
                else if(action == addButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "add");
                }
                else if(action == subButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "sub");
                }
                else if(action == mulButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "mul");
                }
                else if(action == divButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "div");
                }
                else if(action == andButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "and");
                }
                else if(action == orButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "or");
                }
                else if(action == xorButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "xor");
                }
                else if(action == minButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "min");
                }
                else if(action == maxButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "max");
                }
                else if(action == gammaButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "gamma");
                }
                else if(action == calculButton){
                    IJ.runPlugIn("ij.plugin.ImageCalculator", "");
               }
           } catch (Exception ex) {

            }
        }
}
