package ij2x.plugin;

import ij.IJ;
import ij.ImageJ;
import ij.plugin.PlugIn;

import ij2x.util.AWTImages;
import ij2x.util.BorderlessButton;
import ij2x.util.ImageIcons;
import ij2x.util.ResourceString;

import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import java.util.Locale;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;


/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2012</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class MovieControllerPanel extends JPanel implements PlugIn, MovieController, MouseListener, MouseMotionListener, ActionListener{
    private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    private Border lightGrayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.lightGray,Color.lightGray );
    //private Border lightBlue = BorderFactory.createBevelBorder(bb.LOWERED, new Color(144,152,248), new Color(144,152,248));
    //private Border darkBlue = BorderFactory.createBevelBorder(bb.LOWERED, new Color(244,252,248), new Color(244,252,248));
    private long mouseDownTime;
    public boolean startStop = true, flipflop=false;
    public static final int DOUBLE_CLICK_THRESHOLD = 50;
    private boolean pressed;
    public JPanel buttons;
    protected ImageJ ij;
    public JButton draggedButton, closeButton, undecoratedButton, action;
    public JButton tobeginnButton, revButton,
                        startButton, stopButton, fwdButton, toendButton, speedButton;
    public JPanel controlPanel=new JPanel();
    Image[][] icons;
    private static ResourceBundle resources;
    private int index = 0;

    static {
        try {
            resources = ResourceBundle.getBundle("ij2x.plugin.resources.MovieBar",
                                                 Locale.getDefault());
        } catch (MissingResourceException mre) {
            System.err.println("resources/MovieBar.properties not found");
            System.exit(1);
        }
    }


    public MovieControllerPanel(){
        ij = IJ.getInstance();
    }

    public void run(String arg){
        ij = IJ.getInstance();
        controlPanel=controlButton();
    }

    public JPanel controlButton() {
        buttons = new JPanel();
        buttons.setBorder(lightGrayBorder);
        FlowLayout buttonsFlowLayout = new FlowLayout(FlowLayout.LEFT, 0, 0);
        buttons.setLayout(buttonsFlowLayout);

        ImageIcon b1o = ImageIcons.getIcons(this);

        AWTImages.setImageDir("movieDir");


    String[] iconAllName = ResourceString.tokenize(ResourceString.getResourceString(resources, "moviebar"));

    icons = new Image[iconAllName.length][3];
    for(int i=0; i < iconAllName.length; i++){
        for(int j=0; j < 3; j++){
            icons[i][j]=((ImageIcon)AWTImages.createBufferedIcon(
                    this
                      , ResourceString.tokenize(ResourceString.getResourceString(resources, iconAllName[i]))[j]
                        , b1o.getImage()
                          , 24)).getImage();
        }
    }
        revButton=BorderlessButton.createButton(this, revButton, "Revue Button", icons[index++]);

        tobeginnButton=BorderlessButton.createButton(this, tobeginnButton, "Tobeginn Button", icons[index++]);

        startButton=BorderlessButton.createButton(this, startButton, "Start/Stop Button", icons[index++]);

        stopButton=BorderlessButton.createButton(this, stopButton, "Start/Stop Button", icons[index++]);

        fwdButton=BorderlessButton.createButton(this, fwdButton, "Forward Button", icons[index++]);

        toendButton=BorderlessButton.createButton(this, toendButton, "Toend Button", icons[index++]);

        speedButton=BorderlessButton.createButton(this, speedButton, "Speed Button", icons[index]);

        buttons.add(tobeginnButton);
        buttons.add(revButton);
        buttons.add(startButton);
        buttons.add(fwdButton);
        buttons.add(toendButton);
        buttons.add(speedButton);
        return buttons;
    }

    public void toBeginn() {
        //IJ.doCommand("Beginn Slice");
        IJ.runPlugIn("ij.plugin.Animator", "beginn");
    }
    public void toEnd() {
        //IJ.doCommand("End Slice");
        IJ.runPlugIn("ij.plugin.Animator", "end");
    }
    public void previous() {
        IJ.doCommand("Previous Slice");
        startStop = false;
    }
    public void next() {
        IJ.doCommand("Next Slice");
        startStop = false;
    }
    public void start() {
        IJ.doCommand("Start Animation [\\]");
        //IJ.runPlugIn("ij.plugin.Animator", "start");
        startStop = false;
    }
    public void stop() {
        IJ.doCommand("Stop Animation");
        //IJ.runPlugIn("ij.plugin.Animator", "stop");
        startStop=true;
    }
    public void option() {
        IJ.doCommand("Animation Options...");
    }

    public void mousePressed(MouseEvent e) {
        action = (JButton)e.getSource();
        int x = e.getX();
        float rate=0;
        boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
        mouseDownTime = System.currentTimeMillis();
             if (!doubleClick) {
             }
             pressed=true;
     }

     public void mouseReleased(MouseEvent e) {
       JButton action = (JButton)e.getSource();
       int x = e.getX();
       float rate=0;
       boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
       mouseDownTime = System.currentTimeMillis();
            if (pressed) {
                try {
                    if (action == startButton){
                      if(!startStop){
                        //flipflop = true;
                        startButton.setIcon(new ImageIcon(icons[3][0]));
                        startButton.setPressedIcon(new ImageIcon(icons[3][1]));
                        startButton.setRolloverIcon(new ImageIcon(icons[3][2]));
                      }
                      else{ //flipflop=false;
                        startButton.setIcon(new ImageIcon(icons[2][0]));
                        startButton.setPressedIcon(new ImageIcon(icons[2][1]));
                        startButton.setRolloverIcon(new ImageIcon(icons[2][2]));
                      }
                    }
                    else if (action == revButton
                             || action == fwdButton
                               || action == tobeginnButton
                                 || action == toendButton){
                        startStop = true;
                        startButton.setIcon(new ImageIcon(icons[2][0]));
                        startButton.setPressedIcon(new ImageIcon(icons[2][1]));
                        startButton.setRolloverIcon(new ImageIcon(icons[2][2]));
                    }
                }
                catch (Exception qte) {
               qte.printStackTrace();
                }
            }
            pressed=false;
     }
    public void mouseExited(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseDragged(MouseEvent e) {}

    public void mouseMoved(MouseEvent e) {
        JButton action = (JButton) e.getSource();
        int x = e.getX();
        boolean doubleClick = (System.currentTimeMillis() - mouseDownTime) <=
                              DOUBLE_CLICK_THRESHOLD;
        mouseDownTime = System.currentTimeMillis();
        if (!false) {
            if (action == tobeginnButton) {
                IJ.showStatus("Beginn Slice");
            } else if (action == fwdButton) {
                IJ.showStatus("Next Slice");
            } else if (action == startButton) {
                IJ.showStatus("Start/Stop Animation");
            } else if (action == revButton) {
                IJ.showStatus("Previous Slice");
            } else if (action == toendButton) {
                IJ.showStatus("End Slice");
            } else if (action == speedButton) {
                IJ.showStatus("Animation Options...");
            }else if (action == draggedButton) {
                IJ.showStatus("Move...");
            } else if (action == closeButton) {
                IJ.showStatus("Decorated Frame");
            } else if (action == undecoratedButton) {
                IJ.showStatus("Undecorated Frame");
            }

        }
    }
    // Action listener method
    public void actionPerformed(ActionEvent e){
        try {
          if (action == tobeginnButton){
              toBeginn();
          }
            else if (action == revButton){
                previous();
           }
            else if (action == startButton){
              if(startStop){
                  start();
              }else{
                  stop();
             }
            }
            else if (action == fwdButton){
                next();
            }
            else if (action == toendButton){
                toEnd();
            }
            else if (action == speedButton){
                option();
            }
        }
         catch (Exception qte) {
        qte.printStackTrace();
    }

    }
}
